<?php
/*
=============================================================================================
 Filename:          d06020.php
 Description:
     Add new advertiser
---------------------------------------------------------------------------------------------
 Copyright (c) 2011
 Created by AnToN
 Version: 1.0
---------------------------------------------------------------------------------------------
 Parameter Input:
 
=============================================================================================
*/

$SCREENID = 'd0602';
include_once('utkSessionCR.php');
include_once('utkQuery.inc');
$utkQueryMaster = new utkQuery($utkDbase, $utkSessionCR, 'master');
$otorisasi = $utkSessionCR->getLevel();
if($otorisasi == 1){
	include_once('utkChecking.inc');
	$utkChecking = new utkChecking($utkQueryMaster, $utkSessionCR, $utkCommon);
	$hasil = -1;
	$error_msg = checkPost($utkQueryMaster, $utkSessionCR, $utkCommon);
	if(empty($error_msg)){
		$advertiser = $_POST['advertiser'];
		$email = $_POST['email'];
		if($_POST['addadvertiser']==1){
			$sql = "SELECT v_email FROM td_advertiser WHERE v_email = ?";
			$stmt = $utkQueryMaster->parse($sql);
			$utkQueryMaster->bindParam($stmt,'s', $email);
			$utkQueryMaster->execute($stmt);
			$result = $utkQueryMaster->fetch($stmt, true);
			$utkQueryMaster->freeStatement($stmt);
			
			if(is_null($result)){
				$sql = "INSERT INTO td_advertiser (
									v_advertiser, v_email, n_id_create, n_id_update, v_address, v_contact, v_phone, d_posting, d_update
								)VALUES(
								?,?,?,?,?,?,?,NOW(),NOW())";
				$stmt = $utkQueryMaster->parse($sql);
				$utkQueryMaster->bindParam($stmt,"s",$advertiser);
				$utkQueryMaster->bindParam($stmt,"s",$email);				
				$utkQueryMaster->bindParam($stmt,"i",$utkSessionCR->getCsoID());	
				$utkQueryMaster->bindParam($stmt,"i",$utkSessionCR->getCsoID());
				$utkQueryMaster->bindParam($stmt,"s",$_POST['address']);
				$utkQueryMaster->bindParam($stmt,"s",$_POST['contact']);
				$utkQueryMaster->bindParam($stmt,"s",$_POST['phone']);
				$stat = $utkQueryMaster->execute($stmt);
				$row_num = $utkQueryMaster->rowAffected($stmt);
				if($stat && $row_num == 1){
					$hasil = 1;
				}else{
					$error_msg = "Error: Insert Failed.";
				}
				$utkQueryMaster->freeStatement($stmt);
			}
			else{
				$error_msg = "Error: Duplicate advertiser!";
			}
		}
		else{
			$sql = "SELECT v_email FROM td_advertiser WHERE n_advertiser_id != ? AND v_email = ?";
			$stmt = $utkQueryMaster->parse($sql);
			$utkQueryMaster->bindParam($stmt,'i', $_POST['idadvertiser']);
			$utkQueryMaster->bindParam($stmt,'s', $email);
			$utkQueryMaster->execute($stmt);
			$result = $utkQueryMaster->fetch($stmt, true);
			$utkQueryMaster->freeStatement($stmt);
			
			if(is_null($result)){
				$sql = "UPDATE td_advertiser SET v_advertiser = ?, v_email = ?, v_address = ?, v_contact = ?, 
				v_phone = ?, n_id_update = ?, d_update = NOW() WHERE n_advertiser_id = ?";
				$stmt = $utkQueryMaster->parse($sql);
				$utkQueryMaster->bindParam($stmt,"s",$advertiser);
				$utkQueryMaster->bindParam($stmt,"s",$email);
				$utkQueryMaster->bindParam($stmt,"s",$_POST['address']);
				$utkQueryMaster->bindParam($stmt,"s",$_POST['contact']);
				$utkQueryMaster->bindParam($stmt,"s",$_POST['phone']);
				$utkQueryMaster->bindParam($stmt,"i",$utkSessionCR->getCsoID());
				$utkQueryMaster->bindParam($stmt,"i",$_POST['idadvertiser']);	
				$stat = $utkQueryMaster->execute($stmt);
				$row_num = $utkQueryMaster->rowAffected($stmt);
				if($stat && $row_num >= 0){
					$hasil = 2;
				}else{
					$error_msg = "Error: Update Failed.";
				}
				$utkQueryMaster->freeStatement($stmt);
			}
			else{
				$error_msg = "Error: Duplicate Advertiser.";
			}
		}
	}

	if($hasil==1){
		$error_msg = "New Advertiser added.";
		$utkQueryMaster->commit($utkSessionCR);
	}
	elseif($hasil==2){
		$error_msg = "Advertiser updated.";
		$utkQueryMaster->commit($utkSessionCR);
	}
	else{
		if($error_msg == "")
			$error_msg = "Error updating database.";
		$utkQueryMaster->rollback();
	}
	include_once($utkCommon->getPathCRM() . '/d06020.phtml');
}
$utkDbase->disconnect();

function checkPost(&$utkQuery, &$utkSessionCR, &$utkCommon){
	include_once('utkChecking.inc');
	$utkChecking = new utkChecking($utkQuery, $utkSessionCR, $utkCommon);

	if($_POST['addadvertiser']==1)
		$txt = "New Advertiser";
	else
		$txt = "Advertiser";
	$error_message = $utkChecking->checkString($txt, $_POST['advertiser'], true, 100, 0);
	if (!empty($error_message)) return $error_message;

	return "";
}
?>