<?php
	class fcd06040{
		protected $utkQuery;
		protected $utkSession;
		protected $utkCommon;
		
		public function __construct(&$utkQuery, &$utkSession, &$utkCommon){
			$this->utkQuery = &$utkQuery;
			$this->utkSession = &$utkSession;
			$this->utkCommon = &$utkCommon;
		}
		
		public function getTotalCredit(){
			$sql = "SELECT COUNT(1) AS total FROM td_ad_credit ad
          LEFT JOIN tm_user_crm cr on (ad.n_id_create = cr.n_cso_id)					
          INNER JOIN td_active_ads ac on (ac.n_ads_id = ad.n_ads_id)
					INNER JOIN tm_adproduct pr on (ac.n_adproduct_id = pr.n_adproduct_id)
					INNER JOIN td_advertiser adv on (adv.n_advertiser_id = ac.n_advertiser_id)
					WHERE ad.n_approved = 0";
			$stmt = $this->utkQuery->parse($sql);
			$this->utkQuery->execute($stmt);
			$result = $this->utkQuery->fetch($stmt, true);
			$this->utkQuery->freeStatement($stmt);
			$total = $result['TOTAL'];
			return $total;
		}
		
		public function &getCredits($start, $max_rows, $odrby = "ad.d_posting"){
			$sql = "SELECT ad.n_credit_id, ad.n_ads_id, ad.n_credit, ad.n_approved, cr.v_name as cso, 
							date_format(ad.d_posting, '%d %b %Y') as tglposting, 
							adv.v_advertiser, pr.v_product
					FROM td_ad_credit ad 
          LEFT JOIN tm_user_crm cr on (ad.n_id_create = cr.n_cso_id)
          INNER JOIN td_active_ads ac on (ac.n_ads_id = ad.n_ads_id)
					INNER JOIN tm_adproduct pr on (ac.n_adproduct_id = pr.n_adproduct_id)
					INNER JOIN td_advertiser adv on (adv.n_advertiser_id = ac.n_advertiser_id)
					WHERE ad.n_approved = 0
					ORDER BY $odrby
					LIMIT $start, $max_rows";
			$stmt = $this->utkQuery->parse($sql);			
			$this->utkQuery->execute($stmt);			
			return $stmt;
		}
		
		public function &getAdvertisers(){
			$sql = "SELECT 	n_advertiser_id, v_advertiser
					FROM td_advertiser
					ORDER BY v_advertiser";
			$stmt = $this->utkQuery->parse($sql);
			$this->utkQuery->execute($stmt);
			$result = $this->utkQuery->fetchAll($stmt);
			$this->utkQuery->freeStatement($stmt);
			return $result;
		}
		
		public function &getProducts(){
			$sql = "SELECT 	n_adproduct_id, v_product
					FROM tm_adproduct
					WHERE  n_active = 1
					ORDER BY v_product";
			$stmt = $this->utkQuery->parse($sql);
			$this->utkQuery->execute($stmt);
			$result = $this->utkQuery->fetchAll($stmt);
			$this->utkQuery->freeStatement($stmt);
			return $result;
		}
		
		public function &getActiveAds(){
			$sql = "SELECT ad.n_ads_id, adv.v_advertiser, pr.v_product
					FROM td_active_ads ad
					INNER JOIN tm_adproduct pr on (ad.n_adproduct_id = pr.n_adproduct_id)
					INNER JOIN td_advertiser adv on (adv.n_advertiser_id = ad.n_advertiser_id)
					WHERE ad.n_active = 1
					ORDER by ad.d_posting";
			$stmt = $this->utkQuery->parse($sql);
			$this->utkQuery->execute($stmt);
			$result = $this->utkQuery->fetchAll($stmt);
			$this->utkQuery->freeStatement($stmt);
			return $result;
		}
		
		
	}
?>