<?php
/*
=============================================================================================
 Filename: login.php
 Description:
     login
---------------------------------------------------------------------------------------------
 Copyright (c) 2012
 Created by AnToN
 Version: 1.0
---------------------------------------------------------------------------------------------
 Parameter Input:
 =============================================================================================
*/

$SCREENID = 'login';
include_once('utkSessionHP.php');
include_once('utkQuery.inc');
$utkQuery = new utkQuery($utkDbase, $utkSessionHP, 'master');
$error_msg = checkPost($utkQuery, $utkSessionHP, $utkCommon);
$error_msg = str_replace("\"","",$error_msg);
if(empty($error_msg)){
	$email = addslashes($_POST['email']);	
	$pass = base64_encode(addslashes($_POST['pass']));
	if(!(preg_match("/^[\.A-z0-9_\-\+]+[@][A-z0-9_\-]+([.][A-z0-9_\-]+)+[A-z]{1,4}$/", $email)))
		die(msg(0,"You haven't provided a valid email"));
	
	$sql = "SELECT v_email, v_fname, v_lname, n_member_id, v_photo, v_gender, n_newsletter, n_city_id 
					FROM td_member where n_active = ? AND n_valid_email = ? AND v_email = ? AND v_password = ?";
	$stmt = $utkQuery->parse($sql);
	$utkQuery->bindParam($stmt,"i",1);
	$utkQuery->bindParam($stmt,"i",1);
	$utkQuery->bindParam($stmt,"s",$email);
	$utkQuery->bindParam($stmt,"s",$pass);
	$utkQuery->execute($stmt);
	$data = $utkQuery->fetch($stmt);
	if(!empty($data['V_EMAIL'])){
		//create session
		$utkQuerySession = new utkQuery($utkDbase, $utkSessionHP, 'master');
		create_session($utkSessionHP, $utkQuerySession, $_SERVER, $_COOKIE, $PHPSESSID, $data, $utkCommon);
		session_regenerate_id();
		die(msg(1,"member.php"));
	}else{
		$error_msg = "Login Failed.";
		die(msg(0,$error_msg));
	}
	$utkQuery->freeStatement($stmt);	
}
else
	die(msg(0,$error_msg));
$utkDbase->disconnect();

function checkPost(&$utkQuery, &$utkSessionHP, &$utkCommon){
	include_once('utkChecking.inc');
	$utkChecking = new utkChecking($utkQuery, $utkSessionHP, $utkCommon);

	$error_message = $utkChecking->checkAddress('Email', $_POST['email'], true, 100, 1);
	if(!empty($error_message)) return $error_message;
	
	$error_message = $utkChecking->checkString('Password', $_POST['pass'], true, 100, 2);
	if(!empty($error_message)) return $error_message;
	return "";
}

function msg($status,$txt){
	return '{"status":'.$status.',"txt":"'.$txt.'"}';
}

function create_session(&$utkSessionHP, &$utkQuerySession, &$_SERVER, &$_COOKIE, $PHPSESSID, &$data, &$utkCommon){
	$name = $data['V_FNAME'] . ' ' . $data['V_LNAME'];		
	session_unset();
	on_session_destroy(session_id());			
	$session_id = $_COOKIE['SESSDH'];
	if($session_id == '')
		$session_id = $PHPSESSID;
	
	$utkSession = $utkQuerySession->getSession();
	$utkSession->setSession_id($session_id);
	$utkQuerySession->reconnect();			
	if(isset($_COOKIE['SESSHP']))
		setcookie('SESSHP', '', time()-42000, '/');
		
	session_name('SESSDH');
	session_regenerate_id();
	$session_id = session_id();			
	$utkSession->setSession_id($session_id);
	$utkQuerySession->reconnect();
	
	include_once('utkSessionDH.inc');
	$utkSessionDH = new utkSessionDH($utkQuerySession, $utkCommon);
	$utkSessionDH->setSession_id($session_id);
	$utkSessionDH->setMemberID($data['N_MEMBER_ID']);
	$utkSessionDH->setName($name);	
	$utkSessionDH->setEmail($data['V_EMAIL']);	
	$utkSessionDH->setPhoto($data['V_PHOTO']);	
	$utkSessionDH->setGender($data['V_GENDER']);	
	$utkSessionDH->setNewsletter($data['N_NEWSLETTER']);	
	$utkSessionDH->setCity($data['N_CITY_ID']);	
	$utkSessionDH->setIpAddress($_SERVER['REMOTE_ADDR']);
	setcookie("DH_MemberID", $data['N_MEMBER_ID'], time()+7200);
	setcookie("DH_Name", $name, time()+7200);
	setcookie("DH_Email", $data['V_EMAIL'], time()+7200);
	setcookie("DH_Photo", $data['V_PHOTO'], time()+7200);
	setcookie("DH_Gender", $data['V_GENDER'], time()+7200);
	setcookie("DH_Newsletter", $data['N_NEWSLETTER'], time()+7200);
	setcookie("DH_City", $data['N_CITY_ID'], time()+7200);
	$utkSessionDH->addSession();
	
	/*setcookie("DH_Saved", array(), time()+7200);
	$sql = "SELECT n_coupon_id FROM td_coupon_saved where n_id_create = ?";
	$stmt = $utkQuerySession->parse($sql);
	$utkQuerySession->bindParam($stmt,"i",$data['N_MEMBER_ID']);
	$utkQuerySession->execute($stmt);
	while($z = $utkQuerySession->fetch($stmt)){
		array_push($_COOKIE['DH_Saved'],$z['N_COUPON_ID']);
	}
	$utkQuerySession->freeStatement($stmt);	
	
	setcookie("DH_Used", array(), time()+7200);
	$sql = "SELECT n_coupon_id FROM td_coupon_used where n_id_create = ?";
	$stmt = $utkQuerySession->parse($sql);
	$utkQuerySession->bindParam($stmt,"i",$data['N_MEMBER_ID']);
	$utkQuerySession->execute($stmt);
	while($yy = $utkQuerySession->fetch($stmt)){
		array_push($_COOKIE['DH_Used'],$yy['N_COUPON_ID']);
	}
	$utkQuerySession->freeStatement($stmt);	*/
}
?>