<?php
/*
=============================================================================================
 Filename:			productinside.php
 Description:
     Product Inside
---------------------------------------------------------------------------------------------
 Copyright (c) 2012
 Created by AnToN
 Version: 1.0
---------------------------------------------------------------------------------------------
 Parameter Input:

---------------------------------------------------------------------------------------------
 Modification History:
 Version		Date										Update by		Remarks
=============================================================================================
*/
$SCREENID = 'productinside';
$channel = 3;

include_once('utkSessionHP.php');
$utkSessionHP->setHeaderExpired();
	
include_once('utkQuery.inc');
$utkQuerySlave = new utkQuery($utkDbase, $utkSessionHP, 'slave');

include_once('utkCarousel.inc');
$utkCarousel = new utkCarousel($utkQuerySlave, $utkSessionHP, $utkCommon);

include_once('utkBanner.inc');
$utkBanner = new utkBanner($utkQuerySlave, $utkSessionHP, $utkCommon, $channel);

include_once('utkComment.inc');
$utkComment = new utkComment($utkQuerySlave, $utkSessionHP, $utkCommon, $channel);

include_once('utkMenuHP.inc');
$utkMenuHP = new utkMenuHP($utkQuerySlave, $utkSessionHP, $utkCommon);

$sql = "SELECT pr.*, date_add(pr.d_expired, interval 1 day) as tglexp, sp.v_shop, sp.n_shop_id, cat.n_cat_id, 
					cat.v_category, br.n_brand_id, br.v_brand,
					datediff(pr.d_expired,date(NOW())) as selisih, DATE_FORMAT(pr.d_expired,'%d %M %Y') as tglclosing
				from td_product pr LEFT JOIN tm_shop sp on (pr.n_shop_id = sp.n_shop_id)
				LEFT JOIN tm_category cat on (pr.n_cat_id = cat.n_cat_id)
				LEFT JOIN tm_brand br on (pr.n_brand_id = br.n_brand_id)
				where pr.n_prod_id = ".$_GET['id'];
$stmt = $utkQuerySlave->parse($sql);
$utkQuerySlave->execute($stmt);
$val = $utkQuerySlave->fetch($stmt);
$utkQuerySlave->freeStatement($stmt);
list($thnex,$blnex,$tglex) = explode('-',$val['TGLEXP']);
$tglfull = "new Date(".$thnex.",".$blnex."-1,".$tglex.")";
$jmlcatother = $utkMenuHP->getTotalCatDeal($val['N_CAT_ID']);

if($val['N_NETT']>0)
	$net="Rp.".number_format($val['N_NETT'], 0, ',', '.').",-";					
else
	$net="FREE";
			
//counter
if($_COOKIE["_c_pr"][$val['N_PROD_ID']]!="true"){
	setcookie("_c_pr[".$val['N_PROD_ID']."]", "true", time()+3600);
	$sql = "UPDATE td_product SET n_view = n_view + 1, n_credit = n_credit - n_cpc WHERE n_prod_id = ?";
	$stmt = $utkQuerySlave->parse($sql);
	$utkQuerySlave->bindParam($stmt,"i",$_GET['id']);
	$stat2 = $utkQuerySlave->execute($stmt);
	$row_num2 = $utkQuerySlave->rowAffected($stmt);
	if($stat2 && $row_num2 == 1)
		$utkQuerySlave->commit($utkSessionHP);
	else
		$utkQuerySlave->rollback();
}
$utkQuerySlave->freeStatement($stmt);

$sql = "SELECT n_shop_id, v_shop
				FROM tm_shop
				WHERE n_rival = 1";
$stmt = $utkQuerySlave->parse($sql);
$utkQuerySlave->execute($stmt);
$shops = array();
while($v = $utkQuerySlave->fetch($stmt)){
	$shops[$v['N_SHOP_ID']] = $v['V_SHOP'];
}
$utkQuerySlave->freeStatement($stmt);

$titlenc = str_replace("'","&quot;",$utkCommon->decode($val['V_PRODUCT']));		
$urlenc = str_replace("'","&quot;",$utkCommon->getMyServer()."/productinside.php?id=".$val['N_PROD_ID']."&se=".$_GET['se']."&v=1");
$urlenc2 = urlencode("http://diskonhunter.com/r.php?id=".$val['N_PROD_ID']."&se=".$_GET['se']);

$sql = "SELECT v_web_title, v_web_desc, v_web_keyword, n_spc_menu, v_spc_menu, v_spc_menu_img, 
					v_logo, v_splash, v_splash_title, v_fb_username, v_twitter_username, v_slogan, v_fb_page
				FROM tm_config WHERE n_config_id = 1";
$stmt = $utkQuerySlave->parse($sql);
$utkQuerySlave->execute($stmt);
$data = $utkQuerySlave->fetch($stmt);
$utkQuerySlave->freeStatement($stmt);
$utkMenuHP->addPageTitle($utkCommon->decode($data['V_WEB_TITLE']),$utkCommon->decode($val['V_PRODUCT']));
$utkMenuHP->addMeta("keywords",$utkCommon->decode($data['V_WEB_KEYWORD']) .', '. $utkCommon->decode($val['V_PRODUCT']));
$utkMenuHP->addMeta("description",$utkCommon->decode($val['V_DESC']));
$utkMenuHP->printHeader(array('productinside.css','bottom.css','jquery.countdown.css'), array('jquery.pikachoose.js','ui2.js','ui.js','jquery.countdown.min.js'), $utkBanner, $SCREENID, $data);
?>
<meta property="og:title" content="<?=$utkCommon->decode($data['V_WEB_TITLE'])?> | <?=$utkCommon->decode($val['V_PRODUCT'])?>" />
<meta property="og:description" content="<?=strip_tags($utkCommon->decode($val['V_DESC']))?>" />
<meta property="og:image" content="<?=$utkCommon->getImages();?>/products/<?=$val['V_PROD_IMG1']?>" />
<meta property="og:url" content="<?=$utkCommon->getMyServer();?>/productinside.php?id=<?=$_GET['id']?>&se=<?=$_GET['se']?>&v=1" />
<meta property="og:type" content="website" />
<meta property="og:locale" content="en_US" />
<link rel="image_src" href="<?=$utkCommon->getImages();?>/products/<?=$val['V_PROD_IMG1']?>" />
<script type="text/javascript">
jQuery(function ($) {	
	// Load dialog on click
	$('#basic-modal .basic').click(function (e) {
		$('#basic-modal-content').modal();
		return false;
	});
});
$(document).ready(function(){
	$(".toggle_container2").hide();
	$("h3.trigger").click(function(){
		$(this).toggleClass("active").next().slideToggle("slow");
	});	
	$(".toggle_container3").hide();
	$("h5.trigger").click(function(){
		$(this).toggleClass("active").prev().slideToggle("slow");
	});
	$("#pikame").PikaChoose({carousel:true,carouselOptions:{wrap:'circular'}});
	$('#containerhp > ul').tabs({ fx: { height: 'toggle', opacity: 'toggle' } });
	$('.carousel3').css('width','635px');
});
</script>
</head>
<body bgcolor="#FFFFFF" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
<thead align="center" >
<tr>
<td bgcolor="#f0f0f0" height="32">
<?php
$utkMenuHP->getNewsticker();
?>
</td>
</tr>
<tr>
<td bgcolor="#dddddd" height="1">
</td>
</tr>
</thead>
<tbody width="990" border="0" cellpadding="0" cellspacing="0" align="center">
<tr>
<td width="990" height="149" align="center" valign="top">
<?php
$utkMenuHP->printMenu($SCREENID,$data);
?>
</td>
</tr>
<tr>
<td width="990" height="724" align="center" valign="top">
<div  class="box1">
<table width="990" border="0" cellspacing="0" cellpadding="0">
<tr>
<td align="left">
<?php
$utkMenuHP->printSubmenu($SCREENID,$_GET['se']);
list($pop,$pop2,$title) = $utkMenuHP->getPageText($channel);
?>
<div class="space"></div>
<div>&nbsp;&nbsp;<a href="#"><a href="<?=$utkCommon->getMyServer();?>/productlist.php?cat=<?=$val['N_CAT_ID']?>"><?=$utkCommon->decode($val['V_CATEGORY'])?></a> &raquo; <a href="<?=$utkCommon->getMyServer();?>/productlist.php?shop=<?=$val['N_SHOP_ID']?>"><?=$utkCommon->decode($val['V_SHOP'])?></a> &raquo; <a href="<?=$utkCommon->getMyServer();?>/productlist.php?brand=<?=$val['N_BRAND_ID']?>"><?=$utkCommon->decode($val['V_BRAND'])?></a></div>
<div class="productbox">
<div align="left" style=" position:relative">
<?php if($val['N_DISKON']>0){?>
<div style=" position:relative"> <div class="diskontag2" align="center"><?=$val['N_DISKON']?>%<br /><font style="font-size:18px">OFF</font></div> </div>
<? }?>
<div class="pikachoose" style=" position:absolute">

<ul id="pikame" class="jcarousel-skin-pika">
<?php
for($i=1;$i<=12;$i++){
	if($val['V_PROD_IMG'.$i]!=''){
?>
<li><a href="#"><img src="<?=$utkCommon->getImages();?>/products/<?=$val['V_PROD_IMG'.$i]?>" /></a><span><?=$utkCommon->decode($val['V_PRODUCT'])?></span></li>
<?php
	}
}
?>
</ul>
</div>
<div align="left" style="position:relative; margin-left:450px; width:500px; height:560px; display:table;">
<div class="productinside1" style="font-size:20px"><?=$utkCommon->decode($val['V_PRODUCT'])?> <font class="pricebig" style="font-size:20px">now <?=$net?></font></div>
<div align="center"><img src="<?=$utkCommon->getImages();?>/space2.gif"></div> 
<br/>   
<div align="left"><strong> Hotness: </strong> <span style="position:relative;top:3px;">
<?php
	for($z=1;$z<=$val['N_RATING'];$z++){
?>
<img src="<?=$utkCommon->getImages();?>/star_icon.png">
<?php
	}
?>
</span></div>
<div style="margin-left:160px; position:relative">
<div class="fl pr5">    
<!--<strong> Share :</strong>-->
<a name="fb_share" type="button_count" share_url="<?=$urlenc?>" href="http://www.facebook.com/sharer.php?u=<?=$urlenc?>&t=<?=$titlenc?>" onclick="return fbs_click('<?=$urlenc?>','<?=$titlenc?>');">Share</a>
</div>
<div class="fl" style="width:60px">
<iframe src="http://www.facebook.com/plugins/like.php?href=<?=$urlenc?>&amp;layout=button_count&amp;show_faces=false&amp;width=100&amp;action=like&amp;colorscheme=light&amp;height=20" scrolling="no" data-layout="button_count" frameborder="0" style="border:none; overflow:hidden; width:100px; height:20px;" allowTransparency="true"></iframe>
</div>
<div class="fl">
<a href="http://twitter.com/share" class="twitter-share-button" data-url="<?=$urlenc2?>" data-text="<?=$titlenc?>" data-count="horizontal"  data-via="diskonhunter"  data-counturl="<?=$urlenc?>">Tweet</a>
</div>
<div class="fl">
<div class="g-plusone" data-href="<?=$urlenc?>" data-size="medium"></div>
<script type="text/javascript">
	(function() {
		var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true;
		po.src = 'https://apis.google.com/js/plusone.js';
		var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);
	})();
</script>
</div>
</div>
<br/>
    
<div id="containerhp">
<ul class="ui-tabs-nav">			
<li class="ui-tabs-selected"><a href="#frag0"><span>Highlight</span></a></li>
<li class=""><a href="#frag1"><span>Detail</span></a></li>
<li class=""><a href="#frag2"><span>Term &amp; Condition</span></a></li>
<li class=""><a href="#frag3"><span>How to Buy</span></a></li>
</ul>			
<div style="" class="ui-tabs-panel" id="frag0"><?=$utkCommon->decode($val['V_DESC'])?></div>
<div style="" class="ui-tabs-panel ui-tabs-hide" id="frag1"><?=$utkCommon->decode($val['V_DESC2'])?></div>
<div style="" class="ui-tabs-panel ui-tabs-hide" id="frag2"><?=$utkCommon->decode($val['V_DESC3'])?></div> 
<div style="" class="ui-tabs-panel ui-tabs-hide" id="frag3"><?=$utkCommon->decode($val['V_DESC4'])?></div>
</div>
     
<div><br />
<!--pop up <div id='basic-modal' style="position:absolute"><a href='#' class='basic' style="padding-top:45px; padding-left:100px; position:relative; z-index:100"><img src="<?=$utkCommon->getImages();?>/question.png"  border="0"></a></div>
<div id="basic-modal-content" ><strong>Semua promo di halaman ini berstatus aktif dan on-going.<br /></strong><br /> Artinya kamu bisa langsung menikmati promo2 ini dengan menggunakan credit card di mall2 terdekat.</div>-->

<?php
	if($val['N_STORE1']!=''){
?>
<div class="price" align="center">
<h3 class="trigger" align="left"></h3>
<div style="display: none;" class="toggle_container2">
<div class="block">
<!-- Table goes in the document BODY -->
<table class="hovertable">
<tr><th>Shop</th><th>Price</th></tr>
<?php
	for($q=1;$q<=10;$q++){
		if($val['N_STORE'.$q]!=''){
?>
<tr onMouseOver="this.style.backgroundColor='#ffff66';" onMouseOut="this.style.backgroundColor='#d4e3e5';">
	<td><?=$utkCommon->decode($shops[$val['N_STORE'.$q]])?></td><td>Rp <?=number_format($val['N_PRICE'.$q], 0, ',', '.')?>,-</td></tr>
<?php
		}
	}
?>
</table>
</div>
</div>
</div>
<?php
	}
	if($val['V_URL']!=''){
?>
<a title="Shop Now" href="<?=$val['V_URL']?>" target="_blank" rel="no-follow"><div align="center"><img src="<?=$utkCommon->getImages();?>/shop.gif"></div></a>
<? } ?>
</div>
</div> 
 </div>
<?php	if($pop2!=''){ ?><div id="message_box" class="toggle_message"><img id="close_message" style="float:right;cursor:pointer" src="<?=$utkCommon->getImages();?>/12-em-cross.png" /><?=$utkCommon->strip($pop2)?></div><? }?>
</div>
<div align="left"><img src="<?=$utkCommon->getImages();?>/related-product.gif"></div>
<div style="position:relative; top:218px;"> 
<div class="banner1">
<?=$utkBanner->writeBanner(6);?>
</div></div>
<?php
if($jmlcatother>0){
	if($jmlcatother%4!=0 && $jmlcatother>4)
		$max = $jmlcatother-($jmlcatother%4);
	else
		$max = $jmlcatother;
}
else{
	$max=0;
}
if($max==1){$max=0;}
if($max>0)
	$utkCarousel->getCarouselInside2($channel,$val['N_CAT_ID']);
else
	echo "<div style=\"padding-left:280px;height:210px;\"><br /><br /><br /><strong>Maaf, tidak ada produk lain yg berhubungan.</strong></div>";

$utkComment->writeComment('td_prod_comment','n_prod_id',$val['N_PROD_ID'])?>
</td>
</tr>  
</table>
<?=$utkBanner->writeBanner(8);?><br /><br />
<?php
include_once('utkFooterHP.inc');
$utkFooterHP = new utkFooterHP($utkQuerySlave, $utkSessionHP, $utkCommon);
$utkFooterHP->printFooter($SCREENID,$_GET['se'],$data);
?>
</div>
</td>		
<tr><td width="990" height="4"></td></tr>
</table>
</td>
</tr>
</tbody>
</table>
</body>
</html>
<?php
include_once('utkLogging.inc');
$utkLogging = new utkLogging($utkCommon);
//$fileLog = "$channel";	//channel id for banner ad(see in tm_channel_ad)
//$message = $SCREENID;	//screen id
//$utkLogging->writeLogBanner($message, $fileLog, false);
$utkDbase->disconnect();
?>