<?php
/*
=============================================================================================
 Filename:          d05010.php
 Description:
     Add new newsticker
---------------------------------------------------------------------------------------------
 Copyright (c) 2011
 Created by AnToN
 Version: 1.0
---------------------------------------------------------------------------------------------
 Parameter Input:
 
=============================================================================================
*/

$SCREENID = 'd0501';
include_once('utkSessionCR.php');
include_once('utkQuery.inc');
$utkQueryMaster = new utkQuery($utkDbase, $utkSessionCR, 'master');
$otorisasi = $utkSessionCR->getLevel();
if($otorisasi == 1){
	include_once('utkChecking.inc');
	$utkChecking = new utkChecking($utkQueryMaster, $utkSessionCR, $utkCommon);
	$hasil = -1;
	$error_msg = checkPost($utkQueryMaster, $utkSessionCR, $utkCommon);
	if(empty($error_msg)){
		$news = $_POST['news'];
		$url = $_POST['url'];
		if($_POST['addnews']==1){
			$sql = "SELECT v_news FROM td_newsticker WHERE v_news = ?";
			$stmt = $utkQueryMaster->parse($sql);
			$utkQueryMaster->bindParam($stmt,'s', $news);
			$utkQueryMaster->execute($stmt);
			$result = $utkQueryMaster->fetch($stmt, true);
			$utkQueryMaster->freeStatement($stmt);
			
			if(is_null($result)){
				$sql = "INSERT INTO td_newsticker (
									v_news, v_url, n_id_create, n_id_update, d_posting, d_update
								)VALUES(
								?,?,?,?,NOW(),NOW())";
				$stmt = $utkQueryMaster->parse($sql);
				$utkQueryMaster->bindParam($stmt,"s",$news);
				$utkQueryMaster->bindParam($stmt,"s",$url);
				$utkQueryMaster->bindParam($stmt,"i",$utkSessionCR->getCsoID());	
				$utkQueryMaster->bindParam($stmt,"i",$utkSessionCR->getCsoID());
				$stat = $utkQueryMaster->execute($stmt);
				$row_num = $utkQueryMaster->rowAffected($stmt);
				if($stat && $row_num == 1){
					$hasil = 1;
				}else{
					$error_msg = "Error: Insert Failed.";
				}
				$utkQueryMaster->freeStatement($stmt);
			}
			else{
				$error_msg = "Error: Duplicate Newsticker!";
			}
		}
		else{
			$sql = "SELECT v_news FROM td_newsticker WHERE n_news_id != ? AND v_news = ?";
			$stmt = $utkQueryMaster->parse($sql);
			$utkQueryMaster->bindParam($stmt,'i', $_POST['idnews']);
			$utkQueryMaster->bindParam($stmt,'s', $news);
			$utkQueryMaster->execute($stmt);
			$result = $utkQueryMaster->fetch($stmt, true);
			$utkQueryMaster->freeStatement($stmt);
			
			if(is_null($result)){
				$sql = "UPDATE td_newsticker SET v_news = ?, v_url = ?, n_id_update = ?, d_update = NOW() WHERE n_news_id = ?";
				$stmt = $utkQueryMaster->parse($sql);
				$utkQueryMaster->bindParam($stmt,"s",$news);
				$utkQueryMaster->bindParam($stmt,"s",$url);
				$utkQueryMaster->bindParam($stmt,"i",$utkSessionCR->getCsoID());
				$utkQueryMaster->bindParam($stmt,"i",$_POST['idnews']);	
				$stat = $utkQueryMaster->execute($stmt);
				$row_num = $utkQueryMaster->rowAffected($stmt);
				if($stat && $row_num >= 0){
					$hasil = 2;
				}else{
					$error_msg = "Error: Update Failed.";
				}
				$utkQueryMaster->freeStatement($stmt);
			}
			else{
				$error_msg = "Error: Duplicate Newsticker.";
			}
		}
	}

	if($hasil==1){
		$error_msg = "Newsticker added.";
		$utkQueryMaster->commit($utkSessionCR);
	}
	elseif($hasil==2){
		$error_msg = "Newsticker updated.";
		$utkQueryMaster->commit($utkSessionCR);
	}
	else{
		if($error_msg == "")
			$error_msg = "Error updating database.";
		$utkQueryMaster->rollback();
	}
	include_once($utkCommon->getPathCRM() . '/d05010.phtml');
}
$utkDbase->disconnect();

function checkPost(&$utkQuery, &$utkSessionCR, &$utkCommon){
	include_once('utkChecking.inc');
	$utkChecking = new utkChecking($utkQuery, $utkSessionCR, $utkCommon);

	if($_POST['addnews']==1)
		$txt = "New Newsticker";
	else
		$txt = "Newsticker";
	$error_message = $utkChecking->checkString($txt, $_POST['news'], true, 300, 0);
	if (!empty($error_message)) return $error_message;
	
	$error_message = $utkChecking->checkString("Target URL", $_POST['url'], true, 150, 0);
	if (!empty($error_message)) return $error_message;	

	return "";
}
?>