<?php
/*
=============================================================================================
 Filename:          d06010.php
 Description:
     Add new ad product
---------------------------------------------------------------------------------------------
 Copyright (c) 2011
 Created by AnToN
 Version: 1.0
---------------------------------------------------------------------------------------------
 Parameter Input:
 
=============================================================================================
*/

$SCREENID = 'd0601';
include_once('utkSessionCR.php');
include_once('utkQuery.inc');
$utkQueryMaster = new utkQuery($utkDbase, $utkSessionCR, 'master');
$otorisasi = $utkSessionCR->getLevel();
if($otorisasi == 1){
	include_once('utkChecking.inc');
	$utkChecking = new utkChecking($utkQueryMaster, $utkSessionCR, $utkCommon);
	$hasil = -1;
	$error_msg = checkPost($utkQueryMaster, $utkSessionCR, $utkCommon);
	if(empty($error_msg)){
		$product = $_POST['product'];
		if($_POST['addproduct']==1){
			$sql = "SELECT v_product FROM tm_adproduct WHERE v_product = ?";
			$stmt = $utkQueryMaster->parse($sql);
			$utkQueryMaster->bindParam($stmt,'s', $product);
			$utkQueryMaster->execute($stmt);
			$result = $utkQueryMaster->fetch($stmt, true);
			$utkQueryMaster->freeStatement($stmt);
			
			if(is_null($result)){
				$sql = "INSERT INTO tm_adproduct (
									v_product, n_page_id, n_category_id, n_position_id, n_city_id, n_cpc, n_cpi, n_active, 
									n_id_create, n_id_update, d_posting, d_update
								)VALUES(
								?,?,?,?,?,?,?,?,?,?,NOW(),NOW())";
				$stmt = $utkQueryMaster->parse($sql);
				$utkQueryMaster->bindParam($stmt,"s",$product);
				$utkQueryMaster->bindParam($stmt,"i",$_POST['page']);				
				$utkQueryMaster->bindParam($stmt,"i",$_POST['cat']);				
				$utkQueryMaster->bindParam($stmt,"i",$_POST['position']);				
				$utkQueryMaster->bindParam($stmt,"i",$_POST['city']);				
				$utkQueryMaster->bindParam($stmt,"i",$_POST['cpc']);				
				$utkQueryMaster->bindParam($stmt,"i",$_POST['cpi']);				
				$utkQueryMaster->bindParam($stmt,"i",$_POST['active']);				
				$utkQueryMaster->bindParam($stmt,"i",$utkSessionCR->getCsoID());	
				$utkQueryMaster->bindParam($stmt,"i",$utkSessionCR->getCsoID());
				$stat = $utkQueryMaster->execute($stmt);
				$row_num = $utkQueryMaster->rowAffected($stmt);
				if($stat && $row_num == 1){
					$hasil = 1;
				}else{
					$error_msg = "Error: Insert Failed.";
				}
				$utkQueryMaster->freeStatement($stmt);
			}
			else{
				$error_msg = "Error: Duplicate Product!";
			}
		}
		else{
			$sql = "SELECT v_product FROM tm_adproduct WHERE n_adproduct_id != ? AND v_product = ?";
			$stmt = $utkQueryMaster->parse($sql);
			$utkQueryMaster->bindParam($stmt,'i', $_POST['idproduct']);
			$utkQueryMaster->bindParam($stmt,'s', $product);
			$utkQueryMaster->execute($stmt);
			$result = $utkQueryMaster->fetch($stmt, true);
			$utkQueryMaster->freeStatement($stmt);
			
			if(is_null($result)){
				$sql = "UPDATE tm_adproduct SET v_product = ?, n_page_id = ?, n_category_id = ?, n_position_id = ?, 
				n_city_id = ?, n_cpc = ?, n_cpi = ?, n_active = ?, n_id_update = ?, d_update = NOW() WHERE n_adproduct_id = ?";
				$stmt = $utkQueryMaster->parse($sql);
				$utkQueryMaster->bindParam($stmt,"s",$product);
				$utkQueryMaster->bindParam($stmt,"i",$_POST['page']);
				$utkQueryMaster->bindParam($stmt,"i",$_POST['cat']);
				$utkQueryMaster->bindParam($stmt,"i",$_POST['position']);
				$utkQueryMaster->bindParam($stmt,"i",$_POST['city']);
				$utkQueryMaster->bindParam($stmt,"i",$_POST['cpc']);
				$utkQueryMaster->bindParam($stmt,"i",$_POST['cpi']);
				$utkQueryMaster->bindParam($stmt,"i",$_POST['active']);
				$utkQueryMaster->bindParam($stmt,"i",$utkSessionCR->getCsoID());
				$utkQueryMaster->bindParam($stmt,'i', $_POST['idproduct']);
				$stat = $utkQueryMaster->execute($stmt);
				$row_num = $utkQueryMaster->rowAffected($stmt);
				if($stat && $row_num >= 0){
					$hasil = 2;
				}else{
					$error_msg = "Error: Update Failed.";
				}
				$utkQueryMaster->freeStatement($stmt);
			}
			else{
				$error_msg = "Error: Duplicate Product.";
			}
		}
	}

	if($hasil==1){
		$error_msg = "New Product added.";
		$utkQueryMaster->commit($utkSessionCR);
	}
	elseif($hasil==2){
		$error_msg = "Product updated.";
		$utkQueryMaster->commit($utkSessionCR);
	}
	else{
		if($error_msg == "")
			$error_msg = "Error updating database.";
		$utkQueryMaster->rollback();
	}
	include_once($utkCommon->getPathCRM() . '/d06010.phtml');
}
$utkDbase->disconnect();

function checkPost(&$utkQuery, &$utkSessionCR, &$utkCommon){
	include_once('utkChecking.inc');
	$utkChecking = new utkChecking($utkQuery, $utkSessionCR, $utkCommon);

	if($_POST['addproduct']==1)
		$txt = "New Product";
	else
		$txt = "Product";
	$error_message = $utkChecking->checkString($txt, $_POST['product'], true, 150, 0);
	if (!empty($error_message)) return $error_message;

	return "";
}
?>