<?php
class utkDbaseCR {
	protected $conn = array();
	protected $sessionHost = array('localhost');
	protected $showError;
	
	public function __construct($showError = true) {
		$this->showError = $showError;
	}
	
	public function isShowError() {
		return $this->showError;
	}
	
	public function getSessionHost() {
		return $this->sessionHost;
	}
	
	public function &connect(&$utkSession, $server = 'master') {
		$server = strtolower($server);
		$hostSlave = '';
		
		if ($this->conn[$server]) {
			if (!$this->conn[$server]->ping())
				unset($this->conn[$server]);
		}
		
		if (!$this->conn[$server]) {
			if($server == 'session') {
				if (is_null($utkSession))
					$connectID = 0;
				else
					$connectID = ord(substr($utkSession->getSession_id(), 0, 1));
				
				$connectID %= count($this->sessionHost);
				
				$this->realConnect($server, $this->sessionHost[$connectID], 'k8998418_user', 'diskon54321hunter', 'k8998418_diskonhunter', 5);
			}
			else{
				$this->realConnect($server, 'localhost', 'k8998418_user', 'diskon54321hunter', 'k8998418_diskonhunter');
			}
		}
		
		return $this->conn[$server];
	}
	
	private function realConnect($server, $host, $user, $pass, $dbase, $timeout = 30) {
		$this->conn[$server] = mysqli_init();
		$this->conn[$server]->options(MYSQLI_INIT_COMMAND, 'SET AUTOCOMMIT = 0');
		$this->conn[$server]->options(MYSQLI_INIT_COMMAND, "SET INTERACTIVE_TIMEOUT = $timeout");
		$this->conn[$server]->options(MYSQLI_INIT_COMMAND, "SET WAIT_TIMEOUT = $timeout");
		$this->conn[$server]->options(MYSQLI_OPT_CONNECT_TIMEOUT, 5);
		$this->conn[$server]->real_connect($host, $user, $pass, $dbase, null, null, MYSQLI_CLIENT_INTERACTIVE);
		
		if (mysqli_connect_errno()) {
			error_log(printf("Connect failed: %s\n", mysqli_connect_error()), 0);
			exit();
		}
	}
	
	private function resetSlaves(&$utkSession) {
		if (!is_null($utkSession)) {
			$hostSlave = $utkSession->getHostSlave();
			
			if (!empty($hostSlave)){
				$utkSession->setHostSlave('');
				$status = $utkSession->updateSession();
			}
		}
	}
	
	public function disconnect($server = '') {
		if (empty($server)) {
			while (list($key, $value) = each ($this->conn)) {
				if ($this->conn[$key]) {
					if ($this->conn[$key]->ping()) {
						$this->conn[$key]->rollback();
						$this->conn[$key]->close();
					}
					
					unset($this->conn[$key]);
				}
			}
		}
		else {
			$server = strtolower($server);
			
			//Merge session & master
			//if ($server == 'session')
			//	$server = 'master';
			
			if ($this->conn[$server]) {
				if ($this->conn[$server]->ping()) {
					$this->conn[$server]->rollback();
					$this->conn[$server]->close();
				}
				
				unset($this->conn[$server]);
			}
		}
	}
	
	public function &getConnection($server = '') {
		if (empty($server))
			return $this->conn;
		else {
			$server = strtolower($server);
			
			//Merge session & master
			//if ($server == 'session')
			//	$server = 'master';
			
			return $this->conn[$server];
		}
	}
}
?>