<?php
	class utkDelete {
		protected $utkQuery;
		protected $utkSession;
		protected $utkCommon;
		
		public function __construct(&$utkQuery, &$utkSession, &$utkCommon){
			$this->utkQuery = &$utkQuery;
			$this->utkSession = &$utkSession;
			$this->utkCommon = &$utkCommon;
		}
		
		public function hapus($table, $pk, $id){
			$sql = "DELETE FROM $table WHERE $pk = ?";
			$stmt = $this->utkQuery->parse($sql);
			$this->utkQuery->bindParam($stmt, 'i', $id);
			$stat = $this->utkQuery->execute($stmt);
			$row_num = $this->utkQuery->rowAffected($stmt);
			$this->utkQuery->freeStatement($stmt);
			return array($stat, $row_num);
		}
		
		public function flag($table, $pk, $id, $fld, $value){
			$sql = "UPDATE $table SET $fld = ? WHERE $pk = ?";
			$stmt = $this->utkQuery->parse($sql);
			$this->utkQuery->bindParam($stmt, 'i', $value);
			$this->utkQuery->bindParam($stmt, 'i', $id);
			$stat = $this->utkQuery->execute($stmt);
			$row_num = $this->utkQuery->rowAffected($stmt);
			$this->utkQuery->freeStatement($stmt);
			return array($stat, $row_num);
		}
		
		public function flagdate($table, $pk, $id, $fld){
			$sql = "UPDATE $table SET $fld = NOW() WHERE $pk = ?";
			$stmt = $this->utkQuery->parse($sql);
			$this->utkQuery->bindParam($stmt, 'i', $id);
			$stat = $this->utkQuery->execute($stmt);
			$row_num = $this->utkQuery->rowAffected($stmt);
			$this->utkQuery->freeStatement($stmt);
			return array($stat, $row_num);
		}
		
		public function delimg($folder, $img){
			if(is_file("../images/".$folder."/".$img)){
				unlink("../images/".$folder."/".$img);				
			}
			return true;
		}
		
		public function deldata($folder, $video){
			if(is_file("../data/".$folder."/".$video)){
				unlink("../data/".$folder."/".$video);				
			}
			return true;
		}
	}
?>