<?php
class utkPage {
	protected $max_rows = 10;
	protected $max_page = 10;
	protected $start_record = 0;
	protected $end_record = 0;
	protected $counter = 0;
		
	public function __construct($max_rows, $max_page, &$utkCommon, &$utkSession) {
		$this->max_rows = $max_rows;
		$this->max_page = $max_page;
		$this->utkSession = $utkSession;
		$this->utkCommon = $utkCommon;
	}
	
	public function getMaxRow() {
		return $this->max_rows;
	}
	
	public function getTotalPage($total_rows){
		$total_page = intval($total_rows / $this->max_rows);
		
		if ($total_rows % $this->max_rows != 0)
			$total_page++;
			
		return $total_page;
	}
	
	public function getStartRecord($page, $total_rows) {
		if ($page > 0 && $total_rows > 0) {
			$total_pages = $this->getTotalPage($total_rows);
			$page = $page > $total_pages ? $total_pages : $page;
			
			$start_record  = ($page - 1) * $this->max_rows;
			
			return $start_record;
		}
		else
			return 0;
	}
	
	public function getEndRecord($start_record, $total_rows) {
		$end_record = $start_record + $this->max_rows;
		
		if ($end_record > $total_rows)
			$end_record = $total_rows;
			
		return $end_record;
	}
	
	function showPageResult($class, $page, $total_rows, $full = 1) {
		$total_pages = $this->getTotalPage($total_rows);
		if($full==1){
			echo "<p class=\"".$class."\" align=\"center\">Page: " . $page . "/". $total_pages. "</p>";
		}
		else{
			echo "<font class=\"".$class."\">Page: " . $page.'/'.$total_pages. "</font>";
		}
	}
	
	function showPage($class, $type, $msg, $total_rows, $page, $url, $param, $onclick = '') {
		if ($total_rows > 0) {
			$page_str = $page;
			$page = $page == '' ? 1 : $page;
			$page = $page <= 0 ? 1 : $page;
			
			if (!preg_match("/\?/", $url))
				$url .= '?';
			else
				$url .= '&';
			
			$paramClick = '';
			
			if (count($param) > 1) {
				for ($x = 1; $x < count($param); $x++) {
					$url .= $param[$x][0] . "=" . urlencode($param[$x][1]) . "&";
					$paramClick .= "'" . $param[$x][1] . "', ";
				}
				
				$paramClick = preg_replace("/, $/", "", $paramClick);
			}
			//echo " param=".var_dump($param);
			$url .= $param[0][0] . "=";
			
			$total_pages = $this->getTotalPage($total_rows);
			$page = $page > $total_pages ? $total_pages : $page;
			$current_page = intval($page / $this->max_page);
			
			if ($page % $this->max_page)
				$current_page++;
			
			$current_page = ($current_page - 1) * $this->max_page;
			$start = $this->getStartRecord($page, $total_rows);
			
			$end = $this->getEndRecord($start, $total_rows);
			$start++;
			
			echo "<div class=\"".$class."\">";
			
			// Previous
			if ($page > $this->max_page && $total_pages > $this->max_page) {
				$previous = $current_page;
				if ($onclick == '')
					echo "<a href=\"$url$previous\">&laquo;</a>&nbsp;&nbsp;";
				else {
					if ($paramClick == '')
						echo "<a href=\"#\" onclick=\"$onclick('$previous')\">&laquo;</a>&nbsp;&nbsp;";
					else
						echo "<a href=\"#\" onclick=\"$onclick('$previous', $paramClick)\">&laquo;</a>&nbsp;&nbsp;";
				}
			}
			
			if($type != 3){
				//ke halaman:
				if ($total_pages > 1)
					echo "To page: ";
				else
					echo "Page: ";
			}
				
			// Page
			for ($x = $current_page + 1; $x <= $current_page + $this->max_page; $x++) {
				if ($x > $total_pages)
					break;
				
				if ($x == $page){
					if($type == 3 && $page_str == "new"){
						if ($onclick == '')
							echo " <a href=\"$url$x\">[$x]</a>&nbsp;";
						else{
							if ($paramClick == '')
								echo " <a href=\"#\" onclick=\"$onclick('$x')\">$x</a>";
							else
								echo " <a href=\"#\" onclick=\"$onclick('$x', $paramClick)\">$x</a>";
						}
					}else{
						echo " <font color=\"red\">[$x]</font>&nbsp;";
					}
				}else {
					if ($onclick == '')
						echo " <a href=\"$url$x\">[$x]</a>&nbsp;";
					else {
						if ($paramClick == '')
							echo " <a href=\"#\" onclick=\"$onclick('$x')\">$x</a>";
						else
							echo " <a href=\"#\" onclick=\"$onclick('$x', $paramClick)\">$x</a>";
					}
				}
			}	//for ($x = $current_page + 1; $x <= $current_page + $this->max_page; $x++)

			//Next
			if ($total_pages > ($current_page + $this->max_page)) {
				$next = $current_page + $this->max_page + 1;
				
				if ($onclick == '')
					echo "&nbsp;&nbsp;<a href=\"$url$next\">&raquo;</a> ";
				else {
					if ($paramClick == '')
						echo "&nbsp;&nbsp;<a href=\"#\" onclick=\"$onclick('$next')\">&raquo;</a> ";
					else
						echo "&nbsp;&nbsp;<a href=\"#\" onclick=\"$onclick('$next', $paramClick)\">&raquo;</a> ";
				}
			}
			echo "</div>";
		}//if ($total_rows > 0)
	} //end function
}
?>
