<?php
	class utkRSS {
		protected $utkQuery;
		protected $utkSession;
		protected $utkCommon;
		
		public function __construct(&$utkQuery, &$utkSession, &$utkCommon){
			$this->utkQuery = &$utkQuery;
			$this->utkSession = &$utkSession;
			$this->utkCommon = &$utkCommon;
		}
		
		public function generateProd(){
			$status = false;
			$header = $this->getHeader('Products');
			$products = $this->getProd();
			if(!empty($products))
				$status = $this->writeFile('products', $header, $products);
			return $status;
		}
		
		public function generateCoupon(){
			$status = false;
			$header = $this->getHeader('Coupons');
			$coupons = $this->getCoupon();
			if(!empty($coupons))
				$status = $this->writeFile('coupons', $header, $coupons);
			return $status;
		}
		
		public function getHeader($q){
			$sql = "SELECT 	v_main_url, v_web_title, v_web_desc, v_logo
					FROM tm_config WHERE n_config_id = 1";
			$stmt = $this->utkQuery->parse($sql);
			$this->utkQuery->execute($stmt);
			$result = $this->utkQuery->fetch($stmt, true);
			$this->utkQuery->freeStatement($stmt);
			$hdr = '<?xml version="1.0" encoding="ISO-8859-1" ?>
							<rss version="2.0">
                <channel>
                        <title>'.$result['V_WEB_TITLE'].' :: '.$q.'</title>
                        <link>'.$this->utkCommon->getRss().'/'.strtolower($q).'</link>
                        <description>'.$result['V_WEB_DESC'].'</description>
                        <language>Indonesian</language>
                        <image>
                                <title>'.$result['V_WEB_TITLE'].'</title>
                                <url>'.$this->utkCommon->getImages().'/'.$result['V_LOGO'].'</url>
                                <link>'.$result['V_MAIN_URL'].'</link>
                        </image>
												<copyright>Copyright 2011-'.date("Y").' diskonhunter.com</copyright>';
			return $hdr;
		}
		
		public function getProd(){
			$prod = '';
			$sql = "SELECT n_prod_id, v_product, v_desc, v_prod_img, n_price, n_diskon
					FROM td_product
					WHERE d_starting <= NOW() AND d_expired >= NOW() AND n_active = 1
					ORDER BY d_expired";
			$stmt = $this->utkQuery->parse($sql);			
			$this->utkQuery->execute($stmt);
			while($result = $this->utkQuery->fetch($stmt)){
				$link = $this->utkCommon->getMyServer().'/products/detail/'.$result['N_PROD_ID'];
				$prod .= '<item>'.
								 '<title>'. $result['V_PRODUCT'] .'</title>'.
								 '<link>'. $link .'</link>'.
								 '<description><![CDATA['.$result['V_DESC'].']]></description>'.
								 '</item>';
			}
			$this->utkQuery->freeStatement($stmt);
			$prod .= '</channel>
        </rss>';
			return $prod;
		}
		
		public function getCoupon(){
			$coupon = '';
			$sql = "SELECT n_coupon_id, v_coupon, v_desc, v_coupon_img, n_price, n_diskon, date_format(d_posting, '%e %b %Y %H:%i:%s') as tglpublish
					FROM td_coupon
					WHERE d_starting <= NOW() AND d_expired >= NOW() AND n_active = 1
					ORDER BY d_expired";
			$stmt = $this->utkQuery->parse($sql);			
			$this->utkQuery->execute($stmt);
			while($result = $this->utkQuery->fetch($stmt)){
				$link = $this->utkCommon->getMyServer().'/coupons/detail/'.$result['N_COUPON_ID'];
				$coupon .= '<item>'.
								 '<title>'. $result['V_COUPON'] .'</title>'.
								 '<link>'. $link .'</link>'.
								 '<description><![CDATA['.$result['V_DESC'].']]></description>'.
								 '<author>diskonhunter.com</author>'.
								 '<pubDate>'. $result['TGLPUBLISH'] .'</pubDate>'.
								 '</item>';
			}			
			$this->utkQuery->freeStatement($stmt);
			$coupon .= '</channel>
        </rss>';
			return $coupon;
		}
		
		public function writeFile($q, $header, $content){
			$full = $header . $content;
			$status = false;
			$file = $this->utkCommon->getPathRss().'/'.$q.'.xml';
			if(!$handle = fopen($file, 'w+')){
				$msg = "Cannot open file ($file)";
			}
			else{
				if(fwrite($handle, $full) === FALSE) {
					$msg = "Cannot write to file ($file)";
				}
				else{
					$msg = "RSS Updated.";
					$status = true;
				}
				fclose($handle);
			}			
			return array($status, $msg);
		}
	}
?>