<?php
class utkSanitizer {
	protected $utkQuery;
	protected $utkSession;
	protected $utkCommon;
	protected $allowed_lang = array(0,1);
	protected $allowed_tags = "<a><b><strong><i><u><p><span><sup><sub><img><hr><font>"; 
	
	public function __construct(&$utkQuery, &$utkSession, &$utkCommon) {
		$this->utkQuery = &$utkQuery;
		$this->utkSession = &$utkSession;
		$this->utkCommon = &$utkCommon;
	}
	
	public function sanitize($_POST,$_GET){
		$c = count($_GET);
		if($c>0){
			$_GET2 = array();
			foreach($_GET as $key=>$val){
				$val = $this->my_strip_tags($val);
				$_GET2[$key] = $val;
			}
			$_GET = $_GET2;
		}
		
		// BLOCK ALL POST VARIABLE FROM OUTSIDE DOMAIN
		/* if(!empty($_POST)){
			$domain = $this->getDomain($_SERVER["HTTP_REFERER"]);
			$dl = $this->utkCommon->getServerList();
			if(!in_array($domain,$dl)){
				echo "post var blocked from $domain";
				$_POST = array();
				print_r($_POST);
			}
		} */
		
		$c = count($_POST);
		if($c > 0){
			$_POST2 = array();
			foreach($_POST as $key=>$val){
				$val = $this->my_strip_tags($val);
				$_POST2[$key] = $val;
			}
			$_POST = $_POST2;
		}
		
		// sanitize $_GET['language']
		if(isset($_GET['language'])){
			//$_GET["language"] = (int) $_GET["language"];
			if(!in_array($_GET['language'],$this->allowed_lang))
				$_GET["language"] = $this->allowed_lang[0];
		}
	}
	
	protected function my_strip_tags($val){
		if(is_array($val)){
			$tmp = array();
			foreach($val as $key=>$val2){
				$tmp[$key] = strip_tags($val2,$this->allowed_tags);
			}
			return $tmp;
		}else{
			return strip_tags($val,$this->allowed_tags);
		}
	}
	
	protected function getDomain($url){
		if(filter_var($url, FILTER_VALIDATE_URL, FILTER_FLAG_HOST_REQUIRED) === FALSE){
			return false;
		}
		/*** get the url parts ***/
		$parts = parse_url($url);
		/*** return the host domain ***/
		$domain = $parts['scheme'].'://'.$parts['host'];
		if(!empty($parts["port"]))
			$domain .= ":".$parts["port"];
		return $domain;
	}
}
?>