<?php
if(!isset($utkSessionCR)){
	include_once('utkDbase.inc');
	include_once('utkQuery.inc');
	include_once('utkSessionCR.inc');
	include_once('utkCommon.inc');
	
	$utkCommon = new utkCommon();
	
	$utkDbase = new utkDbase();
	
	$utkQuerySession = new utkQuery($utkDbase, 'session');
	$utkSessionCR = new utkSessionCR($utkQuerySession, $utkCommon);
	
	include_once('utkSanitizer.inc');
	$utkSanitizer = new utkSanitizer($utkQuery,$utkSession,$utkCommon);
	$utkSanitizer->sanitize($_POST,$_GET);
	
	function on_session_open ($save_path, $session_name){
		global $sess_save_path;
			 
		$sess_save_path = $save_path;

		return true;
	}

	function on_session_close (){
		return true;
	}

	function on_session_read ($key){
		global $sess_save_path;

		$sess_file = "$sess_save_path/sess_$key";
		
		if (file_exists($sess_file)) {
			$filesize = filesize($sess_file);
			
			if ($filesize > 0) {
				if ($fp = @fopen($sess_file, "r")) {
					$sess_data = fread($fp, $filesize);
					
					return $sess_data;

				}	//if ($fp = @fopen($sess_file, "r"))
				else {
					return true;
				}
			}	//if (filesize($sess_file) > 0)
			else {
				return true;
			}
		}	//if (file_exists($sess_file))
		else {
			return true;
		}
	}

	function on_session_write($key, $sess_data){
		global $sess_save_path;

		$sess_file = "$sess_save_path/sess_$key";
		
		if ($fp = @fopen($sess_file, "w")) {
			return(fwrite($fp, $sess_data));
		}
		else {
			return false;
		}
	}

	function on_session_destroy($key){
		global $sess_save_path;
		
		if (isset($key)) {
			$sess_file = "$sess_save_path/sess_$key";
			
			return(unlink($sess_file));
		}
		
		return true;
	}

	function on_session_gc($MaxLifeTime){
		global $sess_save_path;
		
		$today = time();

		if ($handle = opendir($sess_save_path)) {
			while (false !== ($file = readdir($handle))) { 
				if ($file != "." && $file != "..") {
					$sess_file = "$sess_save_path/$file";
					
					if (filesize($sess_file) == 0 || (($today - filemtime($sess_file)) > $MaxLifeTime)) {
						unlink($sess_file);
					}
				}
			}
			
			closedir($handle); 
		}
		
		return true;
	}
	
//		header ("Expires: Sat, 01 Jan 2000 00:00:00 GMT");
//		header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
//		header ("Cache-Control: private, max-age=3600, must-revalidate");
	header ("Cache-Control: private");
//		header ("Pragma: no-cache");
	
	session_set_save_handler ("on_session_open","on_session_close","on_session_read","on_session_write","on_session_destroy","on_session_gc");
	session_start();
	
	$PHPSESSID = session_id();
	$utkSessionCR->setSession_id($PHPSESSID);
} //if(!isset($utkSessionCR))
?>
