<?php	
class utkData {
	protected $utkQuery;
	protected $utkSession;
	protected $utkCommon;
	protected $lbUtkData;
	
	public function __construct(&$utkQuery, &$utkSession, &$utkCommon)  {
		$this->utkQuery = &$utkQuery;
		$this->utkSession = &$utkSession;
		$this->utkCommon = &$utkCommon;
		
		include_once($this->utkCommon->getPathlbUtility()."/lbUtkData.inc");
		$this->lbUtkData = new lbUtkData($this->utkSession->getLanguage());
	}
	
	public function encode ($txt) {
		if ($txt != '') {
			$txt = preg_replace ("/%/i", "%25", $txt);
			$txt = preg_replace ("/\|/i", "%7C", $txt);
			$txt = preg_replace ("/\r/i", "%0D", $txt);
			$txt = preg_replace ("/\n/i", "%0A", $txt);
		}
		return $txt;
	}
	
	public function decode ($txt) {
		if ($txt != '') {
			$txt = preg_replace ("/%7C/i", "|", $txt);
			$txt = preg_replace ("/%0D/i", "\r", $txt);
			$txt = preg_replace ("/%0A/i", "\n", $txt);
			$txt = preg_replace ("/%25/i", "%", $txt);
		}
		
		return $txt;
	}
	
	public function textToHTML($value, $supportHTML = 0, $tags = '<b><i><u>'){
		if ($supportHTML == 0)
			$value = strip_tags($value, $tags);		
			
		$value = nl2br($value);
		
		return $value;
	}
	
	public function textToHTML2($value){
		$value = strip_tags($value,'<b><i><u>');			
		
		return $value;
	}
	
	public function changeDataToSearch($typ, $value){
		if ($typ == 0) {
			//Insert data
			$value = " $value";
			$value = preg_replace ("/\n\r/i", " ", $value);
			$value = preg_replace ("/\n/i", " ", $value);
			//$value = preg_replace ("/\W/i", " ", $value);
			$value = preg_replace ("/,/i", " ", $value);
			$value = preg_replace ("/ (.) (.) /i", " $1$2 ", $value);
			$value = preg_replace ("/ (.) /i", "$1 ", $value);
			$value = preg_replace ("/ +/i", " ", $value);
		}
		else if ($typ == 1) {
			//Keyword search
			$value = preg_replace ("/\n\r/i", " ", $value);
			$value = preg_replace ("/\n/i", " ", $value);
			//$value = preg_replace ("/\W/i", " ", $value);
			$value = preg_replace ("/,/i", " ", $value);
			$value = preg_replace ("/ +/i", " ", $value);
		}
		
		return strtolower($value);
	}
	
	public function set_phone($pho, $default = -9){
		$v_phone = '';
		$pho = explode ("-", $pho);
	
		for ($f = 0; $f < count($pho); $f++){
			if ($pho[$f] != $default){
				$pho[$f] = htmlentities($pho[$f]);
				$pho[$f] = nl2br($pho[$f]);
				$v_phone .= "$pho[$f]-";
			}
		}
	
		$pho = preg_replace("/-$/","",$v_phone);
		
		return $pho;
	}
	
	public function set_date($date, $status=0, $force_language = -1){
			$language = $force_language != -1?$force_language:$this->utkSession->getLanguage();
			$month_name = array('0' => array('', 'Januari', 'Februari', 'Maret', 'April', 'Mei', 'Juni', 'Juli', 'Agustus', 'September', 'Oktober', 'Nopember', 'Desember'), 
											    '1' => array('', 'January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'));
	
			$date = explode('-', $date);
			$date[1] = preg_replace("/^0/","","$date[1]");
			if($status == 0) {
				$date = "$date[2] " . $month_name[$language][$date[1]] . " $date[0]";
			}else if($status == 1){
				$date = $month_name[$language][$date[1]] . " $date[0]";
			}else if($status == 2){
				$date = $month_name[$language][$date[1]] . " $date[2], $date[0]";
			}
			
			return $date;
	}
	
	function setCellPhone($cntr, $no) {
		if (empty($cntr) or empty($no))
					 $phone = NULL;
		else{
			$cntr = preg_replace("/^0+/", "", $cntr);
			$area = preg_replace("/^0+/", "", $no);

			$cntr = preg_replace("/[^\d]/", "", $cntr);
			$no = preg_replace("/[^\d]/", "", $no);
		  $phone = "$cntr-$no";
		}
		
		return $phone;
	}
	
	public function set_marital($marital){
		
		$marital_status = '';
		
		if ($marital == 1){
			$marital_status = $this->lbUtkData->getMessage(1);
		}
		else if ($marital == 2){
			$marital_status = $this->lbUtkData->getMessage(2);
		}
		else if ($marital == 3){
			$marital_status = $this->lbUtkData->getMessage(3);
		}
		else{
			$marital_status = $this->lbUtkData->getMessage(0);
		}
		
		return $marital_status;
	}
	
	function set_foreign($foreign){
		$foreign_status = '';
					
		if ($foreign == 1){
			$foreign_status = $this->lbUtkData->getMessage(4);
		}
		else if ($foreign == 2){
			$foreign_status = $this->lbUtkData->getMessage(5);
		}
		else if ($foreign == 3){
			$foreign_status = $this->lbUtkData->getMessage(6);
		}
		
		return $foreign_status;
	}
	
	function roundPrice($price) {
		$remain = $price % 1000;
		
		if ($remain > 500) {
			if ($remain > 0)
				$price += (1000 - $remain);
		}
		else {
			if ($remain > 0)
				$price -= $remain;
		}
		
		return $price;
	}
	
	function strip_attribute($str){
		$str = preg_replace("/(<\w+)(\s*\w+\s*=\s*[\'|\"]*[^\'|^\"|^>|^<]*)[\'|\"]*\s*(\>)/","$1$3",$str);
		return $str;
	}
	
	function closeHTML($str){
		$open_pattern = "/<([A-Za-z0-9]+)[^>]*>/";
		$stat = preg_match_all($open_pattern, $str, $open_tag);
		$open_tag = $open_tag[1];
		$open_tag = array_reverse($open_tag);
		
		$close_pattern = "/<\/([A-Za-z0-9]+)[^>]*>/";
		$stat = preg_match_all($close_pattern, $str, $close_tag);
		$close_tag = $close_tag[1];
		
		$add_close = array();
		foreach($open_tag as $tag){
			$idx = array_search($tag,$close_tag);
			if(!is_numeric($idx)){
				$add_close[] = $tag;
			}else{
				array_splice($close_tag,$idx,1);
			}
		}
		$close_str = "";
		foreach($add_close as $ct){
			$close_str .= "</$ct>";
		}
		return $str.$close_str;
	}
}
?>