<?php
class utkMaster {
	protected $utkQuery;
	protected $utkSession;
	protected $utkCommon;
	protected $lbUtkMaster;
	
	public function __construct(&$utkQuery, &$utkSession, &$utkCommon) {
		$this->utkQuery = &$utkQuery;
		$this->utkSession = &$utkSession;
		$this->utkCommon = &$utkCommon;
		
		include_once($this->utkCommon->getPathlbUtility()."/lbUtkMaster.inc");
		$lbUtkMaster = new lbUtkMaster($this->utkSession->getLanguage());
		$this->lbUtkMaster = $lbUtkMaster;
	}
	
	public function getFullMonth($digitMonth, $all = false) {
		$month = array(array('',''),
						 array('Januari','January'),
						 array('Februari','February'),
						 array('Maret','March'),
						 array('April','April'),
						 array('Mei','May'),
						 array('Juni','June'),
						 array('Juli','July'),
						 array('Agustus','August'),
						 array('September','September'),
						 array('Oktober','October'),
						 array('November','November'),
						 array('Desember','December'));
		
		if ($all)
			return $month;
		else
			return $month[$digitMonth][$this->utkSession->getLanguage()];
	}
	
	public function echoHidden($data, $convQuote = true){
		while (list ($name, $value) = each ($data)) {
			if(is_array($value)){
				foreach($value as $v){
					if ($convQuote)
						$v = htmlentities($v);
					
					echo "<input type=\"hidden\" name=\"".$name."[]\" value=\"$v\">\n";
				}
			}else{
				if ($convQuote)
					$value = htmlentities($value);
				
				echo "<input type=\"hidden\" name=\"$name\" value=\"$value\">\n";
			}
		}
	}
	
	public function echoMonthBirth($month_birth){
		$month = $this->getFullMonth($month_birth, true);
						 
		for ($i = 1; $i < count($month); $i++){
			if ($month_birth == $i){
				if($i > 9){
					echo '<option value="'.$i.'" selected="selected">'.$month[$i][$this->utkSession->getLanguage()];
				}
				else{
					echo '<option value="0'.$i.'" selected="selected">'.$month[$i][$this->utkSession->getLanguage()];
				}
			}
			else{
				if($i > 9){
					echo '<option value="'.$i.'">'.$month[$i][$this->utkSession->getLanguage()];
				}
				else{
					echo '<option value="0'.$i.'">'.$month[$i][$this->utkSession->getLanguage()];
				}
			}
		}
	}
	
	public function echoMarital($marital_id){
		$marital_status = array(array('Tidak disebutkan','Not Specified'),
											array('Lajang','Single'),
											array('Menikah','Married'),
											array('Janda/Duda','Widowed'));
		
		for($i = 1; $i < count($marital_status); $i++){
			if($marital_id == $i){
				echo '<option selected value="',$i,'">',$marital_status[$i][$this->utkSession->getLanguage()];
			}
			else{
				echo '<option value="',$i,'">',$marital_status[$i][$this->utkSession->getLanguage()];
			}
		}	
	}
	
	public function echoDegree($selected, $any, $condition){
		$total_selected = count($selected);
		
		if($this->utkSession->getLanguage() == 1){
			$sql = "SELECT n_degree_id, v_english as LINGUA ".
							"FROM tm_degree ";
		}
		else{
			$sql = "SELECT n_degree_id, v_indonesian as LINGUA ".
							"FROM tm_degree ";
		}
		if($condition == 0)
			$sql .= "WHERE n_degree_id > 0	";
		elseif($condition == 1)
			$sql .= "WHERE n_degree_id > 2	";

		if($any == 0){
			$selectany='';
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($selected[$sl]==0){
					$selectany="selected=\"selected\"";
					break;
				}
			}
			echo "<option $selectany value=\"0\">".$this->lbUtkMaster->getMessage(0)."</option>";
		}
		
		// if($this->utkSession->getLanguage() == 1)
			// $sql .= "ORDER BY v_english";
		// else
			// $sql .= "ORDER BY v_indonesian";
			
		$sql .= "ORDER BY n_degree_id";
		
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt)) {
			if ($total_selected > 1){
				$found_selected = 0;
			
				for ($sl = 0; $sl < $total_selected; $sl++){
					if ($result['N_DEGREE_ID'] == $selected[$sl]){
							echo "<option selected value=". $result['N_DEGREE_ID'] . ">" . $result['LINGUA'] . "\n";
							$found_selected = 1;
							break;
					}
				}
			
				if ($found_selected == 0){
					echo "<option value=" . $result['N_DEGREE_ID'] . ">" . $result['LINGUA'] . "\n";
				}
			}
			else{
				if ($result['N_DEGREE_ID'] == $selected){
						echo "<option selected value=". $result['N_DEGREE_ID'] . ">" . $result['LINGUA'] . "\n";
				}
				else{
						echo "<option value=" . $result['N_DEGREE_ID'] . ">" . $result['LINGUA'] . "\n";
				}
			}
		}	
		
		$this->utkQuery->freeStatement($stmt);
	}
	
	public function echoMajor($selected, $any, $condition){
		if(!is_array($selected))
			$selected = array($selected);
		
		$total_selected = count($selected);
		
		if($this->utkSession->getLanguage() == 1){
			$sql = "SELECT n_major_id, v_english as LINGUA ".
							"FROM tm_major ";
		}
		else{
			$sql = "SELECT n_major_id, v_indonesian as LINGUA ".
							"FROM tm_major ";
		}
		
		$sql .= "WHERE n_major_id > 0 ";

		
		if($this->utkSession->getLanguage() == 1)
			$sql .= "ORDER BY v_english";
		else
			$sql .= "ORDER BY v_indonesian";
		
		if($any == 0){
			$selectany='';
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($selected[$sl]==0){
					$selectany="selected=\"selected\"";
					break;
				}
			}
			echo "<option $selectany value=\"0\">".$this->lbUtkMaster->getMessage(0)."</option>";
		}
		
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt)) {
			$found_selected = 0;
		
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($result['N_MAJOR_ID'] == $selected[$sl]){
						echo "<option selected value=". $result['N_MAJOR_ID'] . ">" . $result['LINGUA'] . "\n";
						$found_selected = 1;
						break;
				}
			}
		
			if ($found_selected == 0){
				echo "<option value=" . $result['N_MAJOR_ID'] . ">" . $result['LINGUA'] . "\n";
			}
		}	
		
		$this->utkQuery->freeStatement($stmt);
	}
	
	public function echoJobTitle($selected, $any, $condition){
		if(!is_array($selected))
			$selected = array($selected);
		
		$total_selected = count($selected);
		
		if($this->utkSession->getLanguage() == 1){
			$sql = "SELECT n_title_id, v_english as LINGUA ".
							"FROM tm_job_title ";
		}
		else{
			$sql = "SELECT n_title_id, v_indonesian as LINGUA ".
							"FROM tm_job_title ";
		}
		
		$sql .= "WHERE n_title_id > 0 ";

		if($any == 0){
			$selectany='';
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($selected[$sl]==0){
					$selectany="selected=\"selected\"";
					break;
				}
			}
			echo "<option $selectany value=\"0\">".$this->lbUtkMaster->getMessage(0)."</option>";
		}
		
		if($condition == 1){
			$sql .= "AND n_view_em = 1 ";
		}
		else if($condition == 2){
			$sql .= "AND n_view_js = 1 ";
		}
		else if($condition == 3){
			$sql .= "AND (n_title_id > 6 OR n_title_id = 3) and  n_view_em = 1 ";
		}
		else if($condition == 4){
			$sql .= "AND (n_title_id > 5 AND n_title_id <= 11) and  n_view_em = 1 ";
		}
		
		$sql .= "ORDER BY n_title_id";
				
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt)) {
			$found_selected = 0;
		
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($result['N_TITLE_ID'] == $selected[$sl]){
						echo "<option selected value=". $result['N_TITLE_ID'] . ">" . $result['LINGUA'] . "\n";
						$found_selected = 1;
						break;
				}
			}
		
			if ($found_selected == 0){
				echo "<option value=" . $result['N_TITLE_ID'] . ">" . $result['LINGUA'] . "\n";
			}
		}	
		
		$this->utkQuery->freeStatement($stmt);
	}
	
	public function echoJobFunction($selected, $any, $condition){
		if(!is_array($selected))
			$selected = array($selected);
		
		$total_selected = count($selected);
		
		if($this->utkSession->getLanguage() == 1){
			$sql = "SELECT n_func_id, v_english as LINGUA ".
							"FROM tm_job_function ";
		}
		else{
			$sql = "SELECT n_func_id, v_indonesian as LINGUA ".
							"FROM tm_job_function ";
		}
		
		$sql .= "WHERE n_func_id > 0 ";
		
		if($condition == 1){
			$sql .= "AND n_func_id IN (18,27,28,30,31,45,46,47,83,91,92,93,94,96,108) ";
		}
						
		if($this->utkSession->getLanguage() == 1)
			$sql .= "ORDER BY v_english";
		else
			$sql .= "ORDER BY v_indonesian";			
	
		if($any == 0){
			$selectany='';
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($selected[$sl]==0){
					$selectany="selected=\"selected\"";
					break;
				}
			}
			echo "<option $selectany value=\"0\">".$this->lbUtkMaster->getMessage(0)."</option>";
		}
		
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt)) {
			$found_selected = 0;
		
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($result['N_FUNC_ID'] == $selected[$sl]){
						echo "<option selected value=". $result['N_FUNC_ID'] . ">" . $result['LINGUA'] . "\n";
						$found_selected = 1;
						break;
				}
			}
		
			if ($found_selected == 0){
				echo "<option value=" . $result['N_FUNC_ID'] . ">" . $result['LINGUA'] . "\n";
			}
		}
		
		$this->utkQuery->freeStatement($stmt);
	}
	
	public function echoWorkExp($sort_by, $selected, $any, $condition){
		if(!is_array($selected))
			$selected = array($selected);
		
		$total_selected = count($selected);
		
		if($this->utkSession->getLanguage() == 1){
			$sql = "SELECT n_exp_month, v_english as LINGUA ".
						 "FROM tm_work_exp ";
		}
		else{
			$sql = "SELECT n_exp_month, v_indonesian as LINGUA ".
						 "FROM tm_work_exp ";
		}
		if($condition == 1)
			$sql .= "WHERE n_exp_month > 0 ";

		
		if($sort_by == 0){
			$sql .= "ORDER BY n_exp_month";	
		}
		else{
			if(	$this->utkSession->getLanguage() == 1)
				$sql .= "ORDER BY v_english";
			else
				$sql .= "ORDER BY v_indonesian";
		}
		
		if($any == 0){
			$selectany='';
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($selected[$sl]==0){
					$selectany="selected=\"selected\"";
					break;
				}
			}
			echo "<option $selectany value=\"0\">".$this->lbUtkMaster->getMessage(0)."</option>";
		}
		
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt)) {
			$found_selected = 0;
		
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($result['N_EXP_MONTH'] == $selected[$sl]){
						echo "<option selected value=". $result['N_EXP_MONTH'] . ">" . $result['LINGUA'] . "\n";
						$found_selected = 1;
						break;
				}
			}
		
			if ($found_selected == 0){
				echo "<option value=" . $result['N_EXP_MONTH'] . ">" . $result['LINGUA'] . "\n";
			}
		}	
		
		$this->utkQuery->freeStatement($stmt);
	}
	
	public function libWorkExp($array_no) {
		$this->WorkExp[0]	= "0";
		$this->WorkExp[1]	= "12";
		$this->WorkExp[2]	= "48";
		$this->WorkExp[3]	= "96";
		$this->WorkExp[4]	= "11";
		$this->WorkExp[5]	= "47";
		$this->WorkExp[6]	= "95";
		$this->WorkExp[7]	= "480";
		$this->WorkExp[8]	= "12";
		$this->WorkExp[9]	= "48";
		$this->WorkExp[10]	= "84";
		$this->WorkExp[11]	= "120";
		$this->WorkExp[12]	= "144";
		$message2 = $this->WorkExp[$array_no];
		return $message2;
	}
	
	public function echoLibWorkExp($we){
		for($i=0; $i<6; $i++){
			$db_we = $this->libWorkExp($i+7);
			if ($we==$db_we)
				return $this->lbUtkMaster->getMessage($i+7);
		}
		return '';
	}
	
	public function searchWorkExp($workExp){
		$dwn = '0';
		$up = '0';
		
		for($i=8;$i<=12;$i++){
			$chk = (int) $this->libWorkExp($i);
			if($chk <= $workExp)
				$dwn = $chk;
			if($chk > $workExp && $up == 0)
				$up = $chk;
		}
		return "$dwn-$up";
	}
	
	public function echoWorkExp2($we) {
		for($i=0; $i<4; $i++){
			$db_we = $this->libWorkExp($i)."-".$this->libWorkExp($i+4);
			if ($we==$db_we)
				echo "<option selected value=\"".$this->libWorkExp($i)."-".$this->libWorkExp($i+4)."\">".$this->lbUtkMaster->getMessage($i+3)."</option>";    
			else
				echo "<option value=\"".$this->libWorkExp($i)."-".$this->libWorkExp($i+4)."\">".$this->lbUtkMaster->getMessage($i+3)."</option>";
	  }
	}
	
	public function echoWorkExp3($we) {
		for($i=0; $i<6; $i++){
			$up = $this->libWorkExp($i+7);
			$down = $this->libWorkExp($i+8);
			if($i==0)
				$up = $this->libWorkExp($i);
			if(empty($down)) $down = 0;
			$db_we = $up."-".$down;
			if ($we==$db_we)
				echo "<option selected value=\"".$db_we."\">".$this->lbUtkMaster->getMessage($i+8)."</option>";    
			else
				echo "<option value=\"".$db_we."\">".$this->lbUtkMaster->getMessage($i+8)."</option>";
		}
	}
	
	public function echoWorkExp4($we) {
		for($i=0; $i<4; $i++){
			$sel = '';
			if (($we>=$this->libWorkExp($i)) && ($we<=$this->libWorkExp($i+4)))
				$sel = "selected";
			echo "<option ".$sel." value=\"".$this->libWorkExp($i)."-".$this->libWorkExp($i+4)."\">".$this->lbUtkMaster->getMessage($i+3)."</option>";
	  }
	}
	
	public function echoIndustry($selected, $any, $condition){
		if(!is_array($selected))
			$selected = array($selected);
		
		$total_selected = count($selected);
		
		if($this->utkSession->getLanguage() == 1){
			$sql = "SELECT n_industry_id, v_english as LINGUA ".
							"FROM tm_industry ";
		}
		else{
			$sql = "SELECT n_industry_id, v_indonesian as LINGUA ".
							"FROM tm_industry ";
		}
				
		$sql .= "WHERE n_industry_id > 0 ";
		
		if($this->utkSession->getLanguage() == 1)
			$sql .= "ORDER BY v_english";
		else
			$sql .= "ORDER BY v_indonesian";
		
		if($any == 0 || $any == 2){
			$selectany='';
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($selected[$sl]==0 || $selected[$sl]==''){
					$selectany="selected=\"selected\"";
					break;
				}
			}
			if ($any == 0)
				echo "<option $selectany value=\"0\">" . $this->lbUtkMaster->getMessage(0) . "</option>";
			else if ($any == 2)
				echo "<option $selectany value=\"\"></option>";
		}
		
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt)) {
			$found_selected = 0;
		
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($result['N_INDUSTRY_ID'] == $selected[$sl]){
						echo "<option selected value=". $result['N_INDUSTRY_ID'] . ">" . $result['LINGUA'] . "\n";
						$found_selected = 1;
						break;
				}
			}
		
			if ($found_selected == 0){
				echo "<option value=" . $result['N_INDUSTRY_ID'] . ">" . $result['LINGUA'] . "\n";
			}
		}	
		
		$this->utkQuery->freeStatement($stmt);
	}
	
	public function echoSalary($selected, $any, $condition){
		if(!is_array($selected))
			$selected = array($selected);
		
		$total_selected = count($selected);
		
		if($this->utkSession->getLanguage() == 1){
			$sql = "SELECT n_salary_id, v_english as LINGUA FROM tm_salary ";
		}
		else{
			$sql = "SELECT n_salary_id, v_indonesian as LINGUA FROM tm_salary ";
		}
		
		$sql .= "WHERE n_salary_id > 0 ";
		
		if($any == 0){
			$selectany='';
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($selected[$sl]==0){
					$selectany="selected=\"selected\"";
					break;
				}
			}
			echo "<option $selectany value=\"0\">Any</option>";
		}
		
		if($condition == 1){
			$sql .= "AND n_salary_id NOT in (0,7) ";
		}
		else if($condition == 2){
			$sql .= "AND n_groups = 2 ";
		}
		else if($condition == 3){
			$sql .= "AND n_groups = 1 ";
		}
		else if($condition == 4){
			$sql .= "AND n_groups = 2 OR n_salary_id = 0 ";
		}
		else if($condition == 5){
			$sql .= "AND n_groups = 1 OR n_salary_id = 0 ";
		}

		// if($this->utkSession->getLanguage() == 1)
			// $sql .= "ORDER BY v_english";
		// else
			// $sql .= "ORDER BY v_indonesian";
		$sql .= "ORDER BY n_currency, n_salary_id";
		
		
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt)) {
			$found_selected = 0;
		
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($result['N_SALARY_ID'] == $selected[$sl]){
						echo "<option selected value=". $result['N_SALARY_ID'] . ">" . $result['LINGUA'] . "\n";
						$found_selected = 1;
						break;
				}
			}
		
			if ($found_selected == 0){
				echo "<option value=" . $result['N_SALARY_ID'] . ">" . $result['LINGUA'] . "\n";
			}
		}	
		
		$this->utkQuery->freeStatement($stmt);
	}
	
	public function echoLocation($selected, $any, $condition){
		if(!is_array($selected))
			$selected = array($selected);
		
		$total_selected = count($selected);
		
		if($this->utkSession->getLanguage() == 1){
			$sql = "SELECT n_province_id, n_location_id, v_english AS lingua ".
						 "FROM tm_location ";
		}
		else{
			$sql = "SELECT n_province_id, n_location_id, v_indonesian AS lingua ".
						 "FROM tm_location ";
		}
		
		$sql .= "WHERE n_province_id > 0 ";
		
		if($condition == 1){
			$sql .= "AND n_location_id != 0 AND n_location_id != 999 ";
		}
		else if($condition == 2){
			$sql .= "AND n_province_id NOT IN (0, 99) AND n_location_id = 0 ";
		}
		else if($condition == 3){
			$sql .= "AND n_province_id = 99 AND n_location_id = 999 ";
		}
		else if($condition == 4){
			$sql .= "AND n_province_id != 0 AND n_location_id != 0";
		}
		
		if($this->utkSession->getLanguage() == 1)
			$sql .= "ORDER BY v_english ";
		else
			$sql .= "ORDER BY v_indonesian ";

		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->execute($stmt);
		
		$k=0;
		$l=0;
		$m=0;
		while($result = $this->utkQuery->fetch($stmt)) {
			$prov_loc = $result['N_PROVINCE_ID'] . "-" . $result['N_LOCATION_ID'];
			
			if ($result['N_LOCATION_ID']==0){
				$provinsi[$k]=array($prov_loc,$result['LINGUA']);
				$k++;
			}
			else if ($result['N_LOCATION_ID'] != 0 && $result['N_LOCATION_ID'] != 999) {
				$city[$l]=array($prov_loc,$result['LINGUA']);
				$l++;
			}
			else if ($result['N_PROVINCE_ID'] == 99) {
				$outside[$m]=array($prov_loc,$result['LINGUA']);
				$m++;
			}
		}
		
		if($any == 0){
			$selectany='';
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($selected[$sl] == '0-0'){
					$selectany="selected=\"selected\"";
					break;
				}
			}
			echo "<option $selectany value=\"0-0\">" . $this->lbUtkMaster->getMessage(7) . "</option>";	
			echo "<option Value=\"NuLlS\">&nbsp;</option>";
		}
?>
<option Value="ReMaRkS"><?=$this->lbUtkMaster->getMessage(1)?></option>
<option Value="line">---</option>
<?php
		for ($a=0;$a<=$l;$a++) {
			if ($city[$a][0]!='') {
				$found_selected = 0;
			
				for ($sl = 0; $sl < $total_selected; $sl++){
					if ($city[$a][0] == $selected[$sl]){
							echo "<option selected value=\"".$city[$a][0]."\">".$city[$a][1]."\n";
							$found_selected = 1;
							break;
					}
				}			
				if ($found_selected == 0){
					echo "<option value=\"".$city[$a][0]."\">".$city[$a][1]."\n";
				}
			}
		}
?>
<option Value="NuLlS">&nbsp;</option>
<option Value="ReMaRkS"><?=$this->lbUtkMaster->getMessage(2)?></option>
<option Value="line">---</option>
<?php
		for ($b=0;$b<=$k;$b++) {
			if ($provinsi[$b][0]!='') {
				$found_selected = 0;
			
				for ($sl = 0; $sl < $total_selected; $sl++){
					if ($provinsi[$b][0] == $selected[$sl]){
							echo "<option selected value=\"".$provinsi[$b][0]."\">".$provinsi[$b][1]."\n";
							$found_selected = 1;
							break;
					}
				}
			
				if ($found_selected == 0){
					echo "<option value=\"".$provinsi[$b][0]."\">".$provinsi[$b][1]."\n";
				}
			}
		}
?>
<option Value="line">&nbsp;</option>
<?php
		for ($c=0;$c<=$m;$c++) {
			if ($outside[$c][0]!='') {
				$found_selected = 0;
			
				for ($sl = 0; $sl < $total_selected; $sl++){
					if ($outside[$c][0] == $selected[$sl]){
							echo "<option selected value=\"".$outside[$c][0]."\">".$outside[$c][1]."\n";
							$found_selected = 1;
							break;
					}
				}
			
				if ($found_selected == 0){
					echo "<option value=\"".$outside[$c][0]."\">".$outside[$c][1]."\n";
				}
			}
		}
		
		$this->utkQuery->freeStatement($stmt);
	}
	
	public function echoCertificate($sort_by, $selected, $any, $condition){
		if(!is_array($selected))
			$selected = array($selected);
		
		$total_selected = count($selected);
		
		$sql = "SELECT ce.n_cert_id, ce.v_title, ce.v_issuer ".
					 "FROM tm_certificates ce ".
					 "WHERE EXISTS ".
								"(SELECT ch.n_cert_id ".
								"FROM tj_certificate_holder ch ".
								"WHERE ce.n_cert_id = ch.n_cert_id) ";
		
		$sql .= "AND ce.n_cert_id > 0 ";
		
		if($sort_by == 0){
			$sql .= "ORDER BY ce.v_title";	
		}
		
		if($any == 0){
			$selectany='';
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($selected[$sl]==0){
					$selectany="selected=\"selected\"";
					break;
				}
			}
			echo "<option $selectany value=\"0\">Any</option>";
		}
		
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt)) {
			$found_selected = 0;
		
			for ($sl = 0; $sl < $total_selected; $sl++){
				if ($result[0] == $selected[$sl]){
						echo "<option selected value=\"$result[0]\">$result[1] - $result[2]\n";
						$found_selected = 1;
						break;
				}
			}
		
			if ($found_selected == 0){
				echo "<option value=\"$result[0]\">$result[1] - $result[2]\n";
			}
		}
		
		$this->utkQuery->freeStatement($stmt);
	}
		
	public function getLocation($province_id = 'all', $location_id = 'all'){
		$location_name = array();
		
		if ($this->utkSession->getLanguage() == 1)
			$sql_lang = "v_english";
		else
			$sql_lang = "v_indonesian";
		
		$sql = "SELECT n_province_id, n_location_id, 
									 $sql_lang AS value 
						FROM tm_location ";
		
		if(strtolower($province_id) != 'all' || strtolower($location_id) != 'all')
			$sql .= "WHERE ";
		
		if(strtolower($province_id) != 'all')
			$sql .= "n_province_id = ? AND ";
			
		if(strtolower($location_id) != 'all')
			$sql .= "n_location_id = ? ";
			
		$sql = preg_replace('/ AND $/', '', $sql);
		
		$stmt = $this->utkQuery->parse($sql);
		
		if(strtolower($province_id) != 'all')
			$this->utkQuery->bindParam($stmt, 'i', $province_id);
		
		if(strtolower($location_id) != 'all')
			$this->utkQuery->bindParam($stmt, 'i', $location_id);
		
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt))
			$location_name[("".$result['N_PROVINCE_ID']."-".$result['N_LOCATION_ID']."")] = $result['VALUE'];				
		
		$this->utkQuery->freeStatement($stmt);	
		
		return $location_name;
	}
	
	public function getJobFunction($func_id = 'all'){
		$job_function = array();
		
		if ($this->utkSession->getLanguage() == 1)
			$sql_lang = "v_english";
		else
			$sql_lang = "v_indonesian";
		
		$sql = "SELECT n_func_id, $sql_lang AS lingua 
						FROM tm_job_function ";
		
		if(strtolower($func_id) != 'all')
			$sql .= "WHERE n_func_id = ? ";
		
		$stmt = $this->utkQuery->parse($sql);
		
		if(strtolower($func_id) != 'all')
			$this->utkQuery->bindParam($stmt, 'i', $func_id);
		
		$this->utkQuery->execute($stmt);		
		
		while($result = $this->utkQuery->fetch($stmt))
			$job_function[('m'.$result['N_FUNC_ID'])] = $result['LINGUA'];	

		$this->utkQuery->freeStatement($stmt);
		
		return $job_function;
	}
	
	public function getIndustry($industry_id = 'all'){
		$industry = array();
		
		if ($this->utkSession->getLanguage() == 1)
			$sql_lang = "v_english";
		else
			$sql_lang = "v_indonesian";
		
		$sql = "SELECT n_industry_id, $sql_lang AS lingua 
						FROM tm_industry ";
		
		if(strtolower($industry_id) != 'all')
			$sql .= "WHERE n_industry_id = ? ";		
		
		$stmt = $this->utkQuery->parse($sql);
		
		if(strtolower($industry_id) != 'all')
			$this->utkQuery->bindParam($stmt, 'i', $industry_id);
		
		$this->utkQuery->execute($stmt);		
		
		while($result = $this->utkQuery->fetch($stmt))
			$industry[('m'.$result['N_INDUSTRY_ID'])] = $result['LINGUA'];	

		$this->utkQuery->freeStatement($stmt);
		
		return $industry;
	}
	
	public function getSalary($salary_id = 'all'){
		$salary = array();
		
		if ($this->utkSession->getLanguage() == 1)
			$sql_lang = "v_english";
		else
			$sql_lang = "v_indonesian";
		
		$sql = "SELECT n_salary_id, $sql_lang AS lingua 
						FROM tm_salary ";
		
		if(strtolower($salary_id) != 'all')
			$sql .= "WHERE n_salary_id = ? ";
		
		$stmt = $this->utkQuery->parse($sql);
		
		if(strtolower($salary_id) != 'all')
			$this->utkQuery->bindParam($stmt, 'i', $salary_id);
		
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt))
			$salary[('m'.$result['N_SALARY_ID'])] = $result['LINGUA'];	
		
		$this->utkQuery->freeStatement($stmt);
		
		return $salary;
	}
	
	public function getTitle($title_id = 'all'){
		$salary = array();
		
		if ($this->utkSession->getLanguage() == 1)
			$sql_lang = "v_english";
		else
			$sql_lang = "v_indonesian";
		
		$sql = "SELECT n_title_id, $sql_lang AS lingua 
						FROM tm_job_title ";
		
		if(strtolower($title_id) != 'all')
			$sql .= "WHERE n_title_id = ? ";
		
		$stmt = $this->utkQuery->parse($sql);
		
		if(strtolower($title_id) != 'all')
			$this->utkQuery->bindParam($stmt, 'i', $title_id);
		
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt))
			$salary[('m'.$result['N_TITLE_ID'])] = $result['LINGUA'];	
		
		$this->utkQuery->freeStatement($stmt);
		
		return $salary;
	}
	
	public function getMajor($major_id = 'all'){
		$major = array();
		
		if ($this->utkSession->getLanguage() == 1)
			$sql_lang = "v_english";
		else
			$sql_lang = "v_indonesian";
		
		$sql = "SELECT n_major_id, $sql_lang AS lingua 
						FROM tm_major ";
		
		if(strtolower($major_id) != 'all')
			$sql .= "WHERE n_major_id = ? ";
		
		$stmt = $this->utkQuery->parse($sql);
		
		if(strtolower($major_id) != 'all')
			$this->utkQuery->bindParam($stmt, 'i', $major_id);
		
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt))
			$major[('m'.$result['N_MAJOR_ID'])] = $result['LINGUA'];	
		
		$this->utkQuery->freeStatement($stmt);
		
		return $major;
	}
	
	public function getDegree($degree_id = 'all'){
		$degree = array();
		
		if ($this->utkSession->getLanguage() == 1)
			$sql_lang = "v_english";
		else
			$sql_lang = "v_indonesian";
		
		$sql = "SELECT n_degree_id, $sql_lang AS lingua 
						FROM tm_degree ";
		
		if(strtolower($degree_id) != 'all')
			$sql .= "WHERE n_degree_id = ? ";		
		
		$stmt = $this->utkQuery->parse($sql);
		
		if(strtolower($degree_id) != 'all')
			$this->utkQuery->bindParam($stmt, 'i', $degree_id);
		
		$this->utkQuery->execute($stmt);		
		
		while($result = $this->utkQuery->fetch($stmt))
			$degree[('m'.$result['N_DEGREE_ID'])] = $result['LINGUA'];	
		
		$this->utkQuery->freeStatement($stmt);
		
		return $degree;
	}
	
	public function getWorkExp($work_id = 'all'){
		$work_exp = array();
		
		if ($this->utkSession->getLanguage() == 1)
			$sql_lang = "v_english";
		else
			$sql_lang = "v_indonesian";
		
		$sql = "SELECT n_exp_month, $sql_lang AS lingua 
						FROM tm_work_exp ";
		
		if(strtolower($work_id) != 'all')
			$sql .= "WHERE n_exp_month = ? ";
		
		$stmt = $this->utkQuery->parse($sql);
		
		if(strtolower($work_id) != 'all')
			$this->utkQuery->bindParam($stmt, 'i', $work_id);
		
		$this->utkQuery->execute($stmt);		
		
		while($result = $this->utkQuery->fetch($stmt))
			$work_exp[('m'.$result['N_EXP_MONTH'])] = $result['LINGUA'];	
		
		$this->utkQuery->freeStatement($stmt);
		
		return $work_exp;
	}
	
	public function getCertificates($cert_id = 'all'){
		$cert = array();		
		
		$sql = "SELECT DISTINCT v_issuer 
						FROM tm_certificates 
						WHERE n_class = 1 ";
		
		if(strtolower($cert_id) != 'all')
			$sql .= "AND n_cert_id = ? ";
		else
			$sql .= "AND n_cert_id > 0 ";
			
		$sql .= "ORDER BY v_issuer";
		
		$stmt = $this->utkQuery->parse($sql);
		
		if(strtolower($cert_id) != 'all')
			$this->utkQuery->bindParam($stmt, 'i', $cert_id);
		
		$this->utkQuery->execute($stmt);
		
		while($result = $this->utkQuery->fetch($stmt))
			$cert[] = $result['V_ISSUER'];

		$this->utkQuery->freeStatement($stmt);
		
		return $cert;
	}	

	function encode ($txt) {
		if ($txt != '') {
			$txt = preg_replace ("/%/i", "%25", $txt);
			$txt = preg_replace ("/\|/i", "%7C", $txt);
			$txt = preg_replace ("/\r/i", "%0D", $txt);
			$txt = preg_replace ("/\n/i", "%0A", $txt);
		}
		return $txt;
	}

	function decode ($txt) {
		if ($txt != '') {
			$txt = preg_replace ("/%7C/i", "|", $txt);
			$txt = preg_replace ("/%0D/i", "\r", $txt);
			$txt = preg_replace ("/%0A/i", "\n", $txt);
			$txt = preg_replace ("/%25/i", "%", $txt);
		}
		
		return $txt;
	}

}
?>