<?php
class utkSequence {
	protected $utkQuery;
	protected $utkSession;
	protected $utkCommon;
	
	public function __construct(&$utkQuery, &$utkSession, &$utkCommon) {
		$this->utkQuery = &$utkQuery;
		$this->utkSession = &$utkSession;
		$this->utkCommon = &$utkCommon;
	}
	
	function setErrorSeqID($type, $seq_current, $flagToday = 0){
		if($seq_current != -1) {
			if($flagToday != 0){
				$yearFlag = substr($flagToday,0,4);
				$yearNow = date('Y');
				if($yearFlag != $yearNow){
					// cek cycle
					$sql = "SELECT n_cycle FROM tm_sequence WHERE n_seq_id = ?";
					$stmt = $this->utkQuery->parse($sql);
					$this->utkQuery->bindParam($stmt, 'i', $type);
					$this->utkQuery->execute($stmt);
					$result = $this->utkQuery->fetch($stmt);
					$is_cycle = $result["N_CYCLE"] == 1;
					$this->utkQuery->freeStatement($stmt);
					if($is_cycle){
						return true;
					}
				}
			}
			include_once($this->utkCommon->getPathTable() . '/tbsTmSequenceDel.inc');
			$tbsTmSequenceDel = new tbsTmSequenceDel($this->utkQuery, $this->utkSession, $this->utkCommon);
			$tbsTmSequenceDel->setFieldValue('N_SEQ_ID', $type);
			$tbsTmSequenceDel->setFieldValue('N_SEQ_CURRENT', $seq_current);
			if($flagToday != 0)
				$tbsTmSequenceDel->setFieldValue('D_POSTING', $flagToday);
			else
				$tbsTmSequenceDel->setFieldValue('D_POSTING', 'NOW()', 'h');
			
			$errorMessage = $tbsTmSequenceDel->checkInsert();
			
			if(empty($errorMessage)){
				if($tbsTmSequenceDel->insert($this->utkQuery) == 1) {
					$this->utkQuery->commit();
					return true;
				}
				else {
					$this->utkQuery->rollback();
					return false;
				}
			}
			else 
				return false;
		}
		else
			return false;
	}

	function getNextSeqID($type,$flagToday = 0,$bypass = 0){
        $seq_current = 0;
        $next = 0;
        
		if($bypass == 0){
			$sql = "SELECT
						d.n_seq_current as CURRENT,
						s.n_seq_current as next_seq,
						DATEDIFF(NOW(),d.d_posting) as beda_hari
					FROM
						tm_sequence_del d INNER JOIN tm_sequence s
						ON d.n_seq_id = s.n_seq_id
					WHERE d.n_seq_id = ?
					ORDER BY d.n_seq_current FOR UPDATE";
				
			$stmt = $this->utkQuery->parse($sql);
			$this->utkQuery->bindParam($stmt, 'i', $type);
			$this->utkQuery->execute($stmt);
			
			$result = $this->utkQuery->fetchAll($stmt);
			$this->utkQuery->freeStatement($stmt);
		}else{
			$result = array();
		}
        if (empty($result)) {
            $sql = "SELECT n_seq_start, n_seq_end, ".
                                         "n_seq_current, n_cycle ".
                            "FROM tm_sequence ".
                            "WHERE n_seq_id = ? FOR UPDATE";
        
            $stmt = $this->utkQuery->parse($sql);
            $this->utkQuery->bindParam($stmt, 'i', $type);
            $this->utkQuery->execute($stmt);
            
            if($result = $this->utkQuery->fetch($stmt)) {
                $seq_current_tmp = $result['N_SEQ_CURRENT'];
                
                if ($seq_current_tmp < $result['N_SEQ_END'])
                    $next = 0;
                else {
                    if ($result['N_CYCLE'] == 1) {
                        $next = 1;
                        $seq_current_tmp = $result['N_SEQ_START'];
                    }
                    else {
                        $seq_current = -1;
                        $next = 2;
                    }
                }
            } //if($result = $this->utkQuery->fetch($stmt))
            
            $this->utkQuery->freeStatement($stmt);
            
            include_once($this->utkCommon->getPathTable() . '/tbsTmSequence.inc');
            $tbsTmSequence = new tbsTmSequence($this->utkQuery, $this->utkSession, $this->utkCommon);
            
            $tbsTmSequence->setFieldValue('N_SEQ_ID', $type);
            
            if ($next == 0){
                $tbsTmSequence->setFieldValue('N_SEQ_CURRENT', 'N_SEQ_CURRENT + 1', "h");                
            }
            else if ($next == 1) {
                $tbsTmSequence->setFieldValue('N_SEQ_CURRENT', $seq_current_tmp + 1);
            }
            
            if($next < 2){
                if ($tbsTmSequence->update($this->utkQuery) == 1) {
                    $this->utkQuery->commit();
                    $seq_current = $seq_current_tmp;
                }
                else {
                    $this->utkQuery->rollback();
                    $seq_current = -1;
                }
            }
            else
                $this->utkQuery->rollback();
        }    //if (is_null($result['CURRENT']))
        else {
			$found = false;
			$seq_current_tmp = -1;
			$list_del_seq = array();
			foreach($result as $val){
				$list_del_seq[] = $val["CURRENT"];
			}
			
            while(!$found && $seq_arr = array_shift($result)){
				$seq_current_tmp = $seq_arr['CURRENT'];
				// echo "<br/>checking ".$seq_current_tmp." with: ";
				if($flagToday == 1 && $seq_arr["BEDA_HARI"] != 0){
					for($i=$seq_current_tmp+1;$i<$seq_arr["NEXT_SEQ"];$i++){
						// echo " $i";
						if(!in_array($i,$list_del_seq)){
							// echo "[missing]";
							break;
						}
					}
					// echo "checking ".($i)." with ".$seq_arr["NEXT_SEQ"];
					if($i == $seq_arr["NEXT_SEQ"]){
						$found = true;
						break;
					}
				}else{
					$found = true;
					break;
				}
			}
			if(!$found){
				// echo "<br/>bypass all";
				$seq_current = $this->getNextSeqID($type,$flagToday,1);
			}else{
				include_once($this->utkCommon->getPathTable() . '/tbsTmSequenceDel.inc');
				$tbsTmSequenceDel = new tbsTmSequenceDel($this->utkQuery, $this->utkSession, $this->utkCommon);
				$tbsTmSequenceDel->setFieldValue('N_SEQ_ID', $type);
				$tbsTmSequenceDel->setFieldValue('N_SEQ_CURRENT', $seq_current_tmp);
				if ($tbsTmSequenceDel->delete($this->utkQuery) == 1) {
					$this->utkQuery->commit();
					$seq_current = $seq_current_tmp;
				}else{
					$this->utkQuery->rollback();
					$seq_current = -1;
				}
			}
        }
        
        return $seq_current;
    } 
}
?>