<?php
class utkMyStmt extends mysqli_stmt {
	private $bindParam = array();
	private $bindResult = array();
	private $numRows = 0;
	private $isOpen = true;
	
	public function __construct(&$conn, $query) {
		parent::__construct($conn, $query);
	}
	
	public function addNumRow() {
		$this->numRows++;
	}
	
	public function getNumRow() {
		return $this->numRows;
	}
	
	public function setParam($type, $value) {
		$counter = count($this->bindParam);
		$this->bindParam["$type$counter"] = $value;
	}
	
	public function bindParam() {
		if ($this->param_count > 0 && count($this->bindParam) > 0) {
			$bValue = array();
			$bParam = '';
			$count = 0;
			
			while (list($key, $value) = each ($this->bindParam)) {
				$bParam .= substr($key, 0, 1);
				$bValue[$count++] = &$this->bindParam[$key];
			}
			
			array_unshift($bValue, $bParam);
			
			call_user_func_array(array($this, 'bind_param'), $bValue);
		}
	}
	
	public function getResult($clone = false) {
		if ($clone) {
			$result = array();
			reset($this->bindResult);
			
			while (list($key, $value) = each ($this->bindResult))
				$result[$key] = $value;
			
			return $result;
		}
		else
			return $this->bindResult;
	}
	
	public function bindResult() {
		$meta = $this->result_metadata();
		
		if ($meta) {
			$fields = array();

			$count = 0;

			while($field = $meta->fetch_field())
				$fields[$count++] = &$this->bindResult[strtoupper($field->name)];

			if ($count > 0)
				call_user_func_array(array($this, 'bind_result'), $fields);
			
			$meta->free();
		}
	}
	
	public function close() {
		$this->isOpen = false;
		parent::close();
	}
	
	public function is_open() {
		return $this->isOpen;
	}
	
	public function __toString() {
		return uniqid(rand(), true);
	}
}
?>
