<?php
class utkSessionCR {
	protected $utkQuery;
	protected $utkCommon;
	protected $session_id = '';
	protected $expiration = 0;
	protected $cso_id = '';
	protected $email = '';
	protected $language = 1;
	protected $user_name = '';
	protected $level = 0;
	protected $variable = '';
	protected $host_slave = '';
	protected $last_update = 60;	//in seconds
	protected $ip_address = '';
	protected $randURL = 0;
	protected $is_auth = 0;
	protected $status_session	= 2;	//status_session = 1	-> OK
																	//status_session = 2	-> SESSION INVALID
	
	public function __construct(&$utkQuery, &$utkCommon) {
		$this->utkQuery = &$utkQuery;
		$this->utkCommon = &$utkCommon;
		$this->randURL = rand(1, 99999999);
	}
	
	public function getServerBasedTime($slave) {
		if ($this->last_update < $this->utkCommon->getServerBaseTime())
			return 'master';
		else
			return $slave;
	}
	
	public function getExpiration() {
		return $this->expiration;
	}
	
	public function getCsoID() {
		return $this->cso_id;
	}
	
	public function getEmail() {
		return $this->email;
	}
	
	public function getLanguage() {
		return $this->language;
	}
	
	public function getUserName() {
		return $this->user_name;
	}
	
	public function getLevel() {
		return $this->level;
	}
	
	public function getVariable() {
		return $this->variable;
	}
	
	public function getHostSlave() {
		return $this->host_slave;
	}
	
	public function getLastUpdate() {
		return $this->last_update;
	}
	
	public function getIpAddress() {
		return $this->ip_address;
	}
	
	public function getStatus_session() {
		return $this->status_session;
	}
	
	public function getSession_id() {
		return $this->session_id;
	}
	
	public function getRandURL() {
		return 'yz=' . $this->randURL;
	}
	
	public function setHeaderExpired() {
		header ("Expires: Sat, 01 Jan 2000 00:00:00 GMT");
		header ("Pragma: no-cache");
	}
	
	public function setExpiration($expiration) {
		$this->expiration = $expiration;
		
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$sql = "UPDATE tt_sessions_crm SET n_expiration = ? ".
						"WHERE v_session_id = ?";
						
		$stmt = $this->utkQuery->parse($sql);		
		$this->utkQuery->bindParam($stmt, 'd', $this->expiration);
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);		
		$this->utkQuery->execute($stmt);
		
		if ($this->utkQuery->rowAffected($stmt) == 1) {
			$this->utkQuery->commit();
		}
		
		$this->utkQuery->freeStatement($stmt);
	}
	
	public function setCsoID($cso_id) {
		$this->cso_id = $cso_id;
	}
	
	public function setEmail($email) {
		$this->email = $email;
	}

	public function setLanguage($language) {
		$this->language = $language;
	}
	
	public function setUserName($user_name) {
		$this->user_name = $user_name;
	}
	
	public function setLevel($level) {
		$this->level = $level;
	}
	
	public function setVariable($variable) {
		$this->variable = $variable;
	}
	
	public function setHostSlave($hostSlave) {
		$this->host_slave = $hostSlave;
	}
	
	public function setLastUpdate() {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$sql = "UPDATE tt_sessions_crm SET d_last_update = NOW() ".
						"WHERE v_session_id = ?";
						
		$stmt = $this->utkQuery->parse($sql);
		
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);
		
		$this->utkQuery->execute($stmt);
		
		if ($this->utkQuery->rowAffected($stmt) == 1) {
			$this->utkQuery->commit();
		}
		
		$this->utkQuery->freeStatement($stmt);
		
		$this->last_update = 0;
	}
	
	public function setIpAddress($ipAddress) {
		$this->ip_address = $ipAddress;
	}
	
	public function setStatus_session($statusSession) {
		$this->status_session = $statusSession;
	}
	
	public function setSession_id($sessionID) {
		$this->session_id = $sessionID;
	}
	
	public function getSession() {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$sql = "SELECT a.n_cso_id, b.v_email, a.v_name, a.n_level, 
						a.v_variable, a.v_host_slave, 
						a.n_expiration, TIMESTAMPDIFF(SECOND, a.d_last_update, NOW()) AS n_second, 
						a.v_ip_create 
				FROM tt_sessions_crm a, tm_user_crm b
				WHERE a.n_cso_id = b.n_cso_id 
					  AND v_session_id = ?";
		
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);		
		$this->utkQuery->execute($stmt);
			
		if ($result = $this->utkQuery->fetch($stmt)) {
			$this->expiration = $result['N_EXPIRATION'];
			$this->cso_id = $result['N_CSO_ID'];
			$this->email = $result['V_EMAIL'];
			$this->user_name = $result['V_NAME'];
			$this->level = $result['N_LEVEL'];
			$this->variable = $result['V_VARIABLE'];
			$this->host_slave = $result['V_HOST_SLAVE'];
			$this->last_update = $result['N_SECOND'];
			$this->ip_address = $result['V_IP_CREATE'];
	
			$this->utkQuery->freeStatement($stmt);
			return true;
		}
		else {
			$this->utkQuery->freeStatement($stmt);
			return false;
		}
	}
	
	public function addSession() {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$this->expiration = time();
		
		$sql = "INSERT INTO tt_sessions_crm (v_session_id, n_expiration, 
																				 n_cso_id, v_name, 
																				 n_level, v_variable, 
																				 v_host_slave, d_last_update, 
																				 v_ip_create) 
																 VALUES (?, ?, 
																				 ?, ?, 
																				 ?, ?, 
																				 ?, DATE_SUB(NOW(), INTERVAL 1 DAY), 
																				 ?)";

		$stmt = $this->utkQuery->parse($sql);		
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);
		$this->utkQuery->bindParam($stmt, 'd', $this->expiration);
		$this->utkQuery->bindParam($stmt, 'i', $this->cso_id);
		$this->utkQuery->bindParam($stmt, 's', $this->user_name);
		$this->utkQuery->bindParam($stmt, 'i', $this->level);
		$this->utkQuery->bindParam($stmt, 's', $this->variable);
		$this->utkQuery->bindParam($stmt, 's', $this->host_slave);
		$this->utkQuery->bindParam($stmt, 's', $this->ip_address);		
		$this->utkQuery->execute($stmt);
		
		if ($this->utkQuery->rowAffected($stmt) == 1) {
			$this->utkQuery->commit();
			$this->utkQuery->freeStatement($stmt);
			
			include_once('utkLogging.inc');
			$utkLogging = new utkLogging($this->utkCommon);
			$emailgue = $this->email;
			$cso_id_gw = $this->cso_id;
			$utkLogging->writeLog("$emailgue ($cso_id_gw) \tSuccess - login" , 1);
			return true;
		}
		else {
			$this->utkQuery->freeStatement($stmt);
			return false;
		}
	}
	
	public function updateSession() {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$sql = "UPDATE tt_sessions_crm 
						SET n_expiration = ?, n_cso_id = ?, 
								v_name = ?, n_level = ?, 
								v_variable = ?, v_host_slave = ? 
						WHERE v_session_id = ?";
						
		$stmt = $this->utkQuery->parse($sql);		
		$this->utkQuery->bindParam($stmt, 'd', $this->expiration);
		$this->utkQuery->bindParam($stmt, 'i', $this->cso_id);
		$this->utkQuery->bindParam($stmt, 's', $this->user_name);
		$this->utkQuery->bindParam($stmt, 'i', $this->level);
		$this->utkQuery->bindParam($stmt, 's', $this->variable);
		$this->utkQuery->bindParam($stmt, 's', $this->host_slave);
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);		
		$this->utkQuery->execute($stmt);
		
		if ($this->utkQuery->rowAffected($stmt) == 1) {
			$this->utkQuery->commit();
			$this->utkQuery->freeStatement($stmt);
			return true;
		}
		else {
			$this->utkQuery->freeStatement($stmt);
			return false;
		}
	}
	
	public function deleteSession() {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$sql = "DELETE FROM tt_sessions_crm 
						WHERE v_session_id = ?";
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);			
		$this->utkQuery->execute($stmt);
		
		if ($this->utkQuery->rowAffected($stmt) == 1) {
			$this->utkQuery->commit();
			$this->utkQuery->freeStatement($stmt);
			return true;
		}
		else {
			$this->utkQuery->freeStatement($stmt);
			return false;
		}
	}
	
	public function housekeepingSession($maxlifetime) {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$today = time();
		
		$sql = "DELETE FROM tt_sessions_crm WHERE (? - n_expiration) > ?";
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->bindParam($stmt, 'd', $today);
		$this->utkQuery->bindParam($stmt, 'd', $maxlifetime);		
		$this->utkQuery->execute($stmt);		
		$this->utkQuery->commit();
		$this->utkQuery->freeStatement($stmt);
	}
}
?>