<?php
if(!isset($utkSessionCR)){
	include_once('utkDbaseCR.php');
	include_once('utkQuery.inc');
	include_once('utkSessionCR.inc');
	include_once('utkCommon.inc');
	
	$utkCommon = new utkCommon();
	$utkDbase = new utkDbaseCR();
	
	$utkSessionCR = null;
	$utkQuerySession = new utkQuery($utkDbase, $utkSessionCR, 'session', false);
	$utkSessionCR = new utkSessionCR($utkQuerySession, $utkCommon);
	
	if (empty($noSanitize)) {
		include_once('utkSanitizer.inc');
		$utkSanitizer = new utkSanitizer($utkQuery,$utkSession,$utkCommon);
		$utkSanitizer->sanitize($_POST,$_GET);
	}

	function on_session_open ($save_path, $session_name){
		global $sess_save_path;
			 
		$sess_save_path = $save_path;
		
		return true;
	}
	
	function on_session_close (){
		return true;
	}
	
	function on_session_read ($key){
		global $utkSessionCR, $_SERVER;
		
		$utkSessionCR->setSession_id($key);
		
		if ($utkSessionCR->getSession_id()) {
			if(!$utkSessionCR->getCsoID()) {
				if($utkSessionCR->getSession()) {
					if ($utkSessionCR->getIpAddress() == $_SERVER['REMOTE_ADDR']) {
						$today = time();
						if (($today - $utkSessionCR->getExpiration()) < 10800)	// 10800 seconds / 3 hours
							$utkSessionCR->setExpiration($today);
						else
							$utkSessionCR->setCsoID('');
					}
					else
						$utkSessionCR->setCsoID('');
				}
			}
		}

		if($utkSessionCR->getCsoID())
			$utkSessionCR->setStatus_session(1);	// status_session = 1	-> OK
		else
			$utkSessionCR->setStatus_session(2);	// status_session = 2	-> SESSION INVALID

		//echo "<br>key=$key - status=".$utkSessionCR->getStatus_session()." - session_cso_id=".$utkSessionCR->getCsoID()."<br>";
		return true;
	}
	
	function on_session_write($key, $val){
		return true;
	}
	
	function on_session_destroy($key){
		global $utkSessionCR, $sess_save_path;
		
		if (isset($key)) {
			$utkSessionCR->setSession_id($key);
			$utkSessionCR->deleteSession();
			
			$sess_file = "$sess_save_path/sess_$key";
			
			if (file_exists($sess_file)) {
				unlink($sess_file);
			}
		}
		
		return true;
	}
	
	function on_session_gc($MaxLifeTime){
		global $utkSessionCR, $sess_save_path;
		
		$MaxLifeTime += 7200;
		$today = time();
		$utkSessionCR->housekeepingSession($MaxLifeTime);
		
		if ($handle = opendir($sess_save_path)) {
			while (false !== ($file = readdir($handle))) { 
				if ($file != "." && $file != "..") {
					$sess_file = "$sess_save_path/$file";
					
					if (filesize($sess_file) == 0 || (($today - filemtime($sess_file)) > $MaxLifeTime)) {
						unlink($sess_file);
					}
				}
			}
			
			closedir($handle); 
		}
		
		return true;
	}
	
//		header ("Expires: Sat, 01 Jan 2000 00:00:00 GMT");
//		header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
//		header ("Cache-Control: private, max-age=3600, must-revalidate");
	header ("Cache-Control: private");
//		header ("Pragma: no-cache");
	
	session_set_save_handler ("on_session_open","on_session_close","on_session_read","on_session_write","on_session_destroy","on_session_gc");
	session_name('SESSCR');
	session_start();
	
	$PHPSESSID = session_id();
	$utkSessionCR->setSession_id($PHPSESSID);
} //if(!isset($utkSessionCR))
?>
