<?php
class utkSessionDH {
	protected $utkQuery;
	protected $utkCommon;
	protected $session_id = '';
	protected $expiration = 0;
	protected $member_id = '';
	protected $email = '';
	protected $language = 1;
	protected $name = '';
	protected $photo = '';
	protected $gender = '';
	protected $newsletter = '';
	protected $city = '';
	protected $variable = '';
	protected $host_slave = '';
	protected $last_update = 60;	//in seconds
	protected $ip_address = '';
	protected $randURL = 0;
	protected $is_auth = 0;
	protected $status_session	= 2;	//status_session = 1	-> OK
																	//status_session = 2	-> SESSION INVALID
	
	public function __construct(&$utkQuery, &$utkCommon) {
		$this->utkQuery = &$utkQuery;
		$this->utkCommon = &$utkCommon;
		$this->randURL = rand(1, 99999999);
	}
	
	public function getServerBasedTime($slave) {
		if ($this->last_update < $this->utkCommon->getServerBaseTime())
			return 'master';
		else
			return $slave;
	}
	
	public function getExpiration() {
		return $this->expiration;
	}
	
	public function getMemberID() {
		return $this->member_id;
	}
	
	public function getName() {
		return $this->name;
	}
	
	public function getEmail() {
		return $this->email;
	}
	
	public function getPhoto() {
		return $this->photo;
	}
	
	public function getGender() {
		return $this->gender;
	}
	
	public function getNewsletter() {
		return $this->newsletter;
	}
	
	public function getCity() {
		return $this->city;
	}
	
	public function getLanguage() {
		return $this->language;
	}

	public function getVariable() {
		return $this->variable;
	}
	
	public function getHostSlave() {
		return $this->host_slave;
	}
	
	public function getLastUpdate() {
		return $this->last_update;
	}
	
	public function getIpAddress() {
		return $this->ip_address;
	}
	
	public function getStatus_session() {
		return $this->status_session;
	}
	
	public function getSession_id() {
		return $this->session_id;
	}
	
	public function getRandURL() {
		return 'yz=' . $this->randURL;
	}
	
	public function setHeaderExpired() {
		header ("Expires: Sat, 01 Jan 2000 00:00:00 GMT");
		header ("Pragma: no-cache");
	}
	
	public function setExpiration($expiration) {
		$this->expiration = $expiration;
		
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$sql = "UPDATE tt_sessions_dh SET n_expiration = ? ".
						"WHERE v_session_id = ?";
						
		$stmt = $this->utkQuery->parse($sql);		
		$this->utkQuery->bindParam($stmt, 'd', $this->expiration);
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);		
		$this->utkQuery->execute($stmt);
		
		if ($this->utkQuery->rowAffected($stmt) == 1) {
			$this->utkQuery->commit();
		}
		
		$this->utkQuery->freeStatement($stmt);
	}
	
	public function setMemberID($member_id) {
		$this->member_id = $member_id;
	}
	
	public function setName($name){
		$this->name = $name;
	}
	
	public function setEmail($email) {
		$this->email = $email;
	}
	
	public function setPhoto($photo){
		$this->photo = $photo;
	}
	
	public function setGender($gender){
		$this->gender = $gender;
	}
	
	public function setCity($city){
		$this->city = $city;
	}
	
	public function setNewsletter($city){
		$this->newsletter = $newsletter;
	}

	public function setLanguage($language) {
		$this->language = $language;
	}
	
	public function setVariable($variable) {
		$this->variable = $variable;
	}
	
	public function setHostSlave($hostSlave) {
		$this->host_slave = $hostSlave;
	}
	
	public function setLastUpdate() {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$sql = "UPDATE tt_sessions_dh SET d_last_update = NOW() ".
						"WHERE v_session_id = ?";
						
		$stmt = $this->utkQuery->parse($sql);		
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);		
		$this->utkQuery->execute($stmt);		
		if ($this->utkQuery->rowAffected($stmt) == 1) {
			$this->utkQuery->commit();
		}		
		$this->utkQuery->freeStatement($stmt);		
		$this->last_update = 0;
	}
	
	public function setIpAddress($ipAddress) {
		$this->ip_address = $ipAddress;
	}
	
	public function setStatus_session($statusSession) {
		$this->status_session = $statusSession;
	}
	
	public function setSession_id($sessionID) {
		$this->session_id = $sessionID;
	}
	
	public function getSession() {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$sql = "SELECT a.n_member_id, b.v_email, b.v_fname, b.v_lname, b.v_photo, b.v_gender, 
						b.n_newsletter, b.n_city_id, a.v_variable, a.v_host_slave, 
						a.n_expiration, TIMESTAMPDIFF(SECOND, a.d_last_update, NOW()) AS n_second, 
						a.v_ip_create 
				FROM tt_sessions_dh a, td_member b
				WHERE a.n_member_id = b.n_member_id 
					  AND v_session_id = ?";
		
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);		
		$this->utkQuery->execute($stmt);
			
		if ($result = $this->utkQuery->fetch($stmt)) {
			$name = $result['V_FNAME'] . ' ' . $result['V_LNAME'];
			$this->expiration = $result['N_EXPIRATION'];
			$this->member_id = $result['N_MEMBER_ID'];
			$this->email = $result['V_EMAIL'];
			$this->name = $name;
			$this->photo = $result['V_PHOTO'];
			$this->gender = $result['V_GENDER'];
			$this->newsletter = $result['N_NEWSLETTER'];
			$this->city = $result['N_CITY_ID'];
			$this->variable = $result['V_VARIABLE'];
			$this->host_slave = $result['V_HOST_SLAVE'];
			$this->last_update = $result['N_SECOND'];
			$this->ip_address = $result['V_IP_CREATE'];
	
			$this->utkQuery->freeStatement($stmt);
			return true;
		}
		else {
			$this->utkQuery->freeStatement($stmt);
			return false;
		}
	}
	
	public function addSession() {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$this->expiration = time();
		
		$sql = "INSERT INTO tt_sessions_dh (v_session_id, n_expiration, 
																				 n_member_id, v_variable, 
																				 v_host_slave, d_last_update, 
																				 v_ip_create) 
																 VALUES (?, ?, 
																				 ?, ?, 
																				 ?, DATE_SUB(NOW(), INTERVAL 1 DAY), 
																				 ?)";

		$stmt = $this->utkQuery->parse($sql);		
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);
		$this->utkQuery->bindParam($stmt, 'd', $this->expiration);
		$this->utkQuery->bindParam($stmt, 'i', $this->member_id);
		$this->utkQuery->bindParam($stmt, 's', $this->variable);
		$this->utkQuery->bindParam($stmt, 's', $this->host_slave);
		$this->utkQuery->bindParam($stmt, 's', $this->ip_address);		
		$this->utkQuery->execute($stmt);
		
		if ($this->utkQuery->rowAffected($stmt) == 1) {
			$this->utkQuery->commit();
			$this->utkQuery->freeStatement($stmt);
			
			include_once('utkLogging.inc');
			$utkLogging = new utkLogging($this->utkCommon);
			$emailgue = $this->email;
			$member_id_gw = $this->member_id;
			$utkLogging->writeLog("$emailgue ($member_id_gw) \tSuccess - login" , 2);
			return true;
		}
		else {
			$this->utkQuery->freeStatement($stmt);
			return false;
		}
	}
	
	public function updateSession() {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$sql = "UPDATE tt_sessions_dh 
						SET n_expiration = ?, n_member_id = ?, 
								v_variable = ?, v_host_slave = ? 
						WHERE v_session_id = ?";
						
		$stmt = $this->utkQuery->parse($sql);		
		$this->utkQuery->bindParam($stmt, 'd', $this->expiration);
		$this->utkQuery->bindParam($stmt, 'i', $this->member_id);
		$this->utkQuery->bindParam($stmt, 's', $this->variable);
		$this->utkQuery->bindParam($stmt, 's', $this->host_slave);
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);		
		$this->utkQuery->execute($stmt);
		
		if ($this->utkQuery->rowAffected($stmt) == 1) {
			$this->utkQuery->commit();
			$this->utkQuery->freeStatement($stmt);
			return true;
		}
		else {
			$this->utkQuery->freeStatement($stmt);
			return false;
		}
	}
	
	public function deleteSession() {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$sql = "DELETE FROM tt_sessions_dh 
						WHERE v_session_id = ?";
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->bindParam($stmt, 's', $this->session_id);			
		$this->utkQuery->execute($stmt);
		
		if ($this->utkQuery->rowAffected($stmt) == 1) {
			$this->utkQuery->commit();
			$this->utkQuery->freeStatement($stmt);
			return true;
		}
		else {
			$this->utkQuery->freeStatement($stmt);
			return false;
		}
	}
	
	public function housekeepingSession($maxlifetime) {
		if (!$this->utkQuery->is_connect())
			$this->utkQuery->reconnect();
		
		$today = time();
		
		$sql = "DELETE FROM tt_sessions_dh WHERE (? - n_expiration) > ?";
		$stmt = $this->utkQuery->parse($sql);
		$this->utkQuery->bindParam($stmt, 'd', $today);
		$this->utkQuery->bindParam($stmt, 'd', $maxlifetime);		
		$this->utkQuery->execute($stmt);		
		$this->utkQuery->commit();
		$this->utkQuery->freeStatement($stmt);
	}
}
?>