<?php
if(!isset($utkSessionDH)){
	if (isset($utkSessionHP)) {
		include_once('utkSessionJS.inc');
		$utkSessionJS = new utkSessionJS($utkQuerySession, $utkCommon);
		$utkSessionJS->setSession_id(session_id());
		$utkSessionJS->setLanguage($utkSessionHP->getLanguage());
	}
	else{
		include_once('utkDbaseCR.php');
		include_once('utkQuery.inc');
		include_once('utkSessionDH.inc');
		include_once('utkCommon.inc');
		
		$utkCommon = new utkCommon();
		$utkDbase = new utkDbaseCR();
		
		$utkSessionDH = null;
		$utkQuerySession = new utkQuery($utkDbase, $utkSessionDH, 'session', false);
		$utkSessionDH = new utkSessionDH($utkQuerySession, $utkCommon);
		
		if (empty($noSanitize)) {
			include_once('utkSanitizer.inc');
			$utkSanitizer = new utkSanitizer($utkQuery,$utkSession,$utkCommon);
			$utkSanitizer->sanitize($_POST,$_GET);
		}

		function on_session_open ($save_path, $session_name){
			global $sess_save_path;
				 
			$sess_save_path = $save_path;
			
			return true;
		}
		
		function on_session_close (){
			return true;
		}
		
		function on_session_read ($key){
			global $utkSessionDH, $_SERVER;
			
			$utkSessionDH->setSession_id($key);
			
			if ($utkSessionDH->getSession_id()) {
				if(!$utkSessionDH->getMemberID()) {
					if($utkSessionDH->getSession()) {
						if ($utkSessionDH->getIpAddress() == $_SERVER['REMOTE_ADDR']) {
							$today = time();
							if (($today - $utkSessionDH->getExpiration()) < 10800)	// 10800 seconds / 3 hours
								$utkSessionDH->setExpiration($today);
							else
								$utkSessionDH->setMemberID('');
						}
						else
							$utkSessionDH->setMemberID('');
					}
				}
			}

			if($utkSessionDH->getMemberID())
				$utkSessionDH->setStatus_session(1);	// status_session = 1	-> OK
			else
				$utkSessionDH->setStatus_session(2);	// status_session = 2	-> SESSION INVALID

			//echo "<br>key=$key - status=".$utkSessionDH->getStatus_session()." - session_Member_id=".$utkSessionDH->getMemberID()."<br>";
			return true;
		}
		
		function on_session_write($key, $val){
			return true;
		}
		
		function on_session_destroy($key){
			global $utkSessionDH, $sess_save_path;
			
			if (isset($key)) {
				$utkSessionDH->setSession_id($key);
				$utkSessionDH->deleteSession();
				
				$sess_file = "$sess_save_path/sess_$key";
				
				if (file_exists($sess_file)) {
					unlink($sess_file);
				}
			}
			
			return true;
		}
		
		function on_session_gc($MaxLifeTime){
			global $utkSessionDH, $sess_save_path;
			
			$MaxLifeTime += 7200;
			$today = time();
			$utkSessionDH->housekeepingSession($MaxLifeTime);
			
			if ($handle = opendir($sess_save_path)) {
				while (false !== ($file = readdir($handle))) { 
					if ($file != "." && $file != "..") {
						$sess_file = "$sess_save_path/$file";
						
						if (filesize($sess_file) == 0 || (($today - filemtime($sess_file)) > $MaxLifeTime)) {
							unlink($sess_file);
						}
					}
				}
				
				closedir($handle); 
			}
			
			return true;
		}
		
		//		header ("Expires: Sat, 01 Jan 2000 00:00:00 GMT");
		//		header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
		//		header ("Cache-Control: private, max-age=3600, must-revalidate");
		header ("Cache-Control: private");
		//		header ("Pragma: no-cache");
		
		session_set_save_handler ("on_session_open","on_session_close","on_session_read","on_session_write","on_session_destroy","on_session_gc");
		session_name('SESSDH');
		session_start();
		
		$PHPSESSID = session_id();
		$utkSessionDH->setSession_id($PHPSESSID);
	}
} //if(!isset($utkSessionDH))
?>