<?php
class utkXMLGenerate {
	protected $directoryXML = '/home/httpd/xml/transaction/table';
	
	public function __construct() {
	}
	
	public function saveXML($filename, $objTable) {
		//$tablename = substr(strtolower(get_class($this->objTable)), 3);
		
		if (count($objTable) == 0) {
			$objTable = array($objTable);
		}
		
		$fileXML = $this->directoryXML . "/$filename";
			
		if (file_exists($fileXML)) {
			$doc = new DOMDocument();
			if (!$doc->load($fileXML))
				return "1";
		}
		else {
			if (!$doc = new DOMDocument("1.0")) {
				return "1";
			}
			else {
				$process = $doc->createElement("process");
	
				// We insert the new element as root (child of the document)
				$process = $doc->appendChild($process);
			}
		}
		
		$process = $doc->getElementsByTagName("process");
		$process = $process->item(0);
		
		//Transaction
		$trans = $doc->createElement("tra");
		$trans = $process->appendChild($trans);
		
		for ($t = 0; $t < count($objTable); $t++) {
			$objPerTable = $objTable[$t];
			
			$tablename = $objPerTable->getTablename();
			
			//Table
			$table = $doc->createElement("tbl");
			$table = $trans->appendChild($table);
			$table->setAttribute("n", $tablename);
			$table->setAttribute("p", $objPerTable->getTransaction());
			
			if ($objPerTable->getTransaction() == 'i') {
				$fieldTable = $objPerTable->getFieldName();
			}
			else if ($objPerTable->getTransaction() == 'u') {
				$fieldTable = $objPerTable->getUpdateXMLTable();
			}
			else if ($objPerTable->getTransaction() == 'd') {
				$fieldTable = $objPerTable->getKeyXMLTable();
			}
			
			while (list($key, $value) = each($fieldTable)) {
				//Field
				if ($value[0] == 'h') {
					changeHardValue($objPerTable, $value, $key);
				}
				
				$field = $doc->createElement("fl", $value[1]);
				$field = $table->appendChild($field);
				$field->setAttribute("n", $key);
				$field->setAttribute("t", $value[0]);
				$field->setAttribute("l", $value[2]);
				
//					echo "$key - $value[0] - $value[1]<BR>";
			}	//while (list($key, $value) = each($fieldTable))
			
			if ($objPerTable->getTransaction() != 'i') {
				$primarykeyTable = $objPerTable->getKeyXMLTable();
				
				while (list($key, $value) = each($primarykeyTable)) {
					//Primary Key
					$primarykey = $doc->createElement("ky", $value[1]);
					$primarykey = $table->appendChild($primarykey);
					$primarykey->setAttribute("n", $key);
					$primarykey->setAttribute("t", $value[0]);
					$primarykey->setAttribute("l", $value[2]);
				}	//while (list($key, $value) = each($primarykeyTable))
			}	//if ($objPerTable->getTransaction() != 'i')

			$fileAdditional = $objPerTable->getXMLAdd()->getXMLFile();
			
			if (count($fileAdditional) > 0) {
				//File
				if ($objPerTable->getTransaction() == 'd') {
					$file = $doc->createElement("fil");
					$file = $trans->appendChild($file);
					$file->setAttribute("n", $fileAdditional[0]);
				}
				else {
					$file = $doc->createElement("fil", $fileAdditional[2]);
					$file = $trans->appendChild($file);
					$file->setAttribute("n", $fileAdditional[0]);
					$file->setAttribute("t", $fileAdditional[1]);
				}
			}	//if (count($fileAdditional > 0)
			
			$methodcallName = $objPerTable->getXMLAdd()->getMethodcallName();
			
			if (!is_null($methodcallName)) {
				//Method Call
				$methodcall = $doc->createElement("cal");
				$methodcall = $trans->appendChild($methodcall);
				$methodcall->setAttribute("n", $methodcallName);
				
				$methodcallParam = $objPerTable->getXMLAdd()->getMethodcallParam();
					
				for ($p = 0; $p < count($methodcallParam); $p+=2) {
					$param = $doc->createElement("pr", $methodcallParam[$p+1]);
					$param = $methodcall->appendChild($param);
					$param->setAttribute("n", $methodcallParam[$p]);
				}	//for ($p = 0; $p < count($methodcallParam); $p+=2)
			}	//if (!is_null($methodcallName))
		}	//for ($t = 0; $t < count($objTable); $t++)
		
		if (count($objTable) > 0) {
			if (!$doc->save($fileXML)) {
				return 1;
			}
		}
		
		return 0;
	}
	
	public function getXMLTrans($objTable) {
		//$tablename = substr(strtolower(get_class($this->objTable)), 3);
		
		if (count($objTable) == 0) {
			$objTable = array($objTable);
		}
		
		if (!$doc = new DOMDocument("1.0")) {
			return "";
		} else {
			$process = $doc->createElement("process");

			// We insert the new element as root (child of the document)
			$process = $doc->appendChild($process);
		}
		
		$process = $doc->getElementsByTagName("process");
		$process = $process->item(0);
		
		//Transaction
		$trans = $doc->createElement("tra");
		$trans = $process->appendChild($trans);
		
		for ($t = 0; $t < count($objTable); $t++) {
			$objPerTable = $objTable[$t];
			
			$tablename = $objPerTable->getTablename();
			
			//Table
			$table = $doc->createElement("tbl");
			$table = $trans->appendChild($table);
			$table->setAttribute("n", $tablename);
			$table->setAttribute("p", $objPerTable->getTransaction());
			
			if ($objPerTable->getTransaction() == 'i') {
				$fieldTable = $objPerTable->getFieldName();
			}
			else if ($objPerTable->getTransaction() == 'u') {
				$fieldTable = $objPerTable->getUpdateXMLTable();
			}
			else if ($objPerTable->getTransaction() == 'd') {
				$fieldTable = $objPerTable->getKeyXMLTable();
			}
			
			while (list($key, $value) = each($fieldTable)) {
				//Field
				if ($value[0] == 'h') {
					changeHardValue($objPerTable, $value, $key);
				}
				
				$field = $doc->createElement("fl", $value[1]);
				$field = $table->appendChild($field);
				$field->setAttribute("n", $key);
				$field->setAttribute("t", $value[0]);
				$field->setAttribute("l", $value[2]);
				
//					echo "$key - $value[0] - $value[1]<BR>";
			}	//while (list($key, $value) = each($fieldTable))
			
			if ($objPerTable->getTransaction() != 'i') {
				$primarykeyTable = $objPerTable->getKeyXMLTable();
				
				while (list($key, $value) = each($primarykeyTable)) {
					//Primary Key
					$primarykey = $doc->createElement("ky", $value[1]);
					$primarykey = $table->appendChild($primarykey);
					$primarykey->setAttribute("n", $key);
					$primarykey->setAttribute("t", $value[0]);
					$primarykey->setAttribute("l", $value[2]);
				}	//while (list($key, $value) = each($primarykeyTable))
			}	//if ($objPerTable->getTransaction() != 'i')
		}	//for ($t = 0; $t < count($objTable); $t++)
		
		if (count($objTable) > 0) {
			return $doc->saveXML();
		}
		
		return "";
	}
}

public function changeHardValue(&$objTable, &$content, $field) {
	$tablename = $objTable->getTableName();

	$type = 'n';
	$sql_field = $field;

	if (strtolower($content[1]) == 'now()') {
		$sql_field = "DATE_FORMAT($field, '%Y-%m-%d %H:%i:%s') AS $field";
		$type = 't';
	}
	
	$sql = "SELECT $sql_field 
					FROM $tablename 
					WHERE ";
	
	$primarykey = $objTable->getKeyXMLTable();
	
	if (count($primarykey) > 0) {
		while (list($key, $value) = each($primarykey)) {
			if ($value[0] == 't' && $value[1] != '') {
				$sql .= "$key=STR_TO_DATE(?, '%Y-%m-%d %H:%i:%s') AND ";
			}
			else if ($value[0] == 'h') {
				$sql .= "$key=$value[1] AND ";
			}
			else if ($value[0] == 'o' && $value[1] != '') {
				$lengthDecimal = $value[2] - 1;
				$sql .= "CAST(? AS DECIMAL($lengthDecimal,0)),";
			}
			else {
				$sql .= "$key=? AND ";
			}
		}	//while (list($key, $value) = each($primarykey))
		
		$sql = substr($sql, 0, strlen($sql) - 5);
		
//			echo "$sql<BR>";
		
		$stmt = $objTable->utQuery->parse($sql);
		
		reset($primarykey);
		while (list($key, $value) = each($primarykey)) {
			if ($value[0] != 'h') {
				if ($value[0] == 't' || $value[0] == 'o')
					$value[0] = 's';
						
				$objTable->utQuery->bindParam($stmt, $value[0], $value[1]);
			}
		}	//while (list($key, $value) = each($primarykey))
		
		$objTable->utQuery->execute($stmt);
		
		if ($result = $objTable->utQuery->fetch($stmt)) {
			//eval ("\$objTable->set" . strtoupper(substr($field, 0, 1)) . substr($field, 1) . "('" . $result[strtoupper($field)] . "', '$type');");
			$content = array ($type, $result[strtoupper($field)]);
		}
		
		$objTable->utQuery->freeStatement($stmt);
	}	//if (count($primarykey) > 0)
}
?>                                         
